/* baobab-scanner.c generated by valac 0.56.14, the Vala compiler
 * generated from baobab-scanner.vala, do not modify */

/* -*- tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*- */
/* Baobab - disk usage analyzer
 *
 * Copyright (C) 2012  Ryan Lortie <desrt@desrt.ca>
 * Copyright (C) 2012  Paolo Borelli <pborelli@gnome.org>
 * Copyright (C) 2012  Stefano Facchini <stefano.facchini@gmail.com>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */
#if !defined VALA_STRICT_C && defined __GNUC__ && __GNUC__ >= 14
#pragma GCC diagnostic warning "-Wimplicit-function-declaration"
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#pragma GCC diagnostic warning "-Wint-conversion"
#pragma GCC diagnostic warning "-Wreturn-mismatch"
#endif

#include "baobab.h"
#include <gio/gio.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <gtk/gtk.h>
#include <float.h>
#include <math.h>
#include <glib-object.h>

#define BAOBAB_SCANNER_ATTRIBUTES G_FILE_ATTRIBUTE_STANDARD_NAME "," G_FILE_ATTRIBUTE_STANDARD_DISPLAY_NAME "," G_FILE_ATTRIBUTE_STANDARD_TYPE "," G_FILE_ATTRIBUTE_STANDARD_SIZE "," G_FILE_ATTRIBUTE_STANDARD_ALLOCATED_SIZE "," G_FILE_ATTRIBUTE_TIME_MODIFIED "," G_FILE_ATTRIBUTE_UNIX_NLINK "," G_FILE_ATTRIBUTE_UNIX_INODE "," G_FILE_ATTRIBUTE_UNIX_DEVICE "," G_FILE_ATTRIBUTE_ACCESS_CAN_READ

typedef struct _BaobabScannerHardLink BaobabScannerHardLink;
typedef struct _BaobabScannerResultsArray BaobabScannerResultsArray;
enum  {
	BAOBAB_SCANNER_0_PROPERTY,
	BAOBAB_SCANNER_DIRECTORY_PROPERTY,
	BAOBAB_SCANNER_SCAN_FLAGS_PROPERTY,
	BAOBAB_SCANNER_SHOW_ALLOCATED_SIZE_PROPERTY,
	BAOBAB_SCANNER_TOTAL_SIZE_PROPERTY,
	BAOBAB_SCANNER_TOTAL_ELEMENTS_PROPERTY,
	BAOBAB_SCANNER_MAX_DEPTH_PROPERTY,
	BAOBAB_SCANNER_NUM_PROPERTIES
};
static GParamSpec* baobab_scanner_properties[BAOBAB_SCANNER_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_thread_unref0(var) ((var == NULL) ? NULL : (var = (g_thread_unref (var), NULL)))
#define _g_hash_table_unref0(var) ((var == NULL) ? NULL : (var = (g_hash_table_unref (var), NULL)))
#define _g_async_queue_unref0(var) ((var == NULL) ? NULL : (var = (g_async_queue_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _BaobabScannerResults BaobabScannerResults;
#define _baobab_scanner_results_free0(var) ((var == NULL) ? NULL : (var = (baobab_scanner_results_free (var), NULL)))
#define _baobab_scanner_hard_link_free0(var) ((var == NULL) ? NULL : (var = (baobab_scanner_hard_link_free (var), NULL)))
#define _baobab_scanner_results_array_free0(var) ((var == NULL) ? NULL : (var = (baobab_scanner_results_array_free (var), NULL)))
#define __vala_GtkTreeIter_free0(var) ((var == NULL) ? NULL : (var = (_vala_GtkTreeIter_free (var), NULL)))
enum  {
	BAOBAB_SCANNER_COMPLETED_SIGNAL,
	BAOBAB_SCANNER_NUM_SIGNALS
};
static guint baobab_scanner_signals[BAOBAB_SCANNER_NUM_SIGNALS] = {0};

struct _BaobabScannerPrivate {
	GFile* _directory;
	BaobabScanFlags _scan_flags;
	gboolean _show_allocated_size;
	guint64 _total_size;
	gint _total_elements;
	gint _max_depth;
	GThread* thread;
	guint process_result_idle;
	GHashTable* hardlinks;
	GHashTable* excluded_locations;
	guint32 unix_device;
	gboolean successful;
	GAsyncQueue* results_queue;
	BaobabScanner* self;
	GCancellable* cancellable;
	GError* scan_error;
};

struct _BaobabScannerResultsArray {
	BaobabScannerResults** results;
	gint results_length1;
	gint _results_size_;
};

struct _BaobabScannerResults {
	BaobabScannerResults* parent;
	gchar* name;
	gchar* display_name;
	GFileType file_type;
	guint64 size;
	guint64 time_modified;
	gint elements;
	gdouble percent;
	gint max_depth;
	GError* error;
	gboolean child_error;
	GtkTreeIter iter;
	gboolean iter_is_set;
};

struct _BaobabScannerHardLink {
	guint64 inode;
	guint32 device;
};

static gint BaobabScanner_private_offset;
static gpointer baobab_scanner_parent_class = NULL;

static void baobab_scanner_hard_link_free (BaobabScannerHardLink * self);
static void baobab_scanner_results_array_free (BaobabScannerResultsArray * self);
static void _g_free0_ (gpointer var);
static inline void _g_list_free__g_free0_ (GList* self);
static void baobab_scanner_results_free (BaobabScannerResults * self);
static void baobab_scanner_add_children (BaobabScanner* self,
                                  GFile* directory,
                                  BaobabScannerResults* results,
                                  BaobabScannerResultsArray* results_array,
                                  GError** error);
static BaobabScannerResults* baobab_scanner_add_directory (BaobabScanner* self,
                                                    GFile* directory,
                                                    GFileInfo* info,
                                                    BaobabScannerResults* parent);
static void baobab_scanner_results_update_with_child (BaobabScannerResults* self,
                                               BaobabScannerResults* child);
static void _vala_array_add3 (BaobabScannerResults** * array,
                       gint* length,
                       gint* size,
                       BaobabScannerResults* value);
static BaobabScannerHardLink* baobab_scanner_hard_link_new (GFileInfo* info);
static BaobabScannerResults* baobab_scanner_results_new (GFileInfo* info,
                                                  BaobabScannerResults* parent_results);
static void baobab_scanner_set_total_size (BaobabScanner* self,
                                    guint64 value);
static void baobab_scanner_set_total_elements (BaobabScanner* self,
                                        gint value);
static void _vala_array_add4 (BaobabScannerResults** * array,
                       gint* length,
                       gint* size,
                       BaobabScannerResults* value);
static BaobabScannerResultsArray* baobab_scanner_results_array_new (void);
static void* baobab_scanner_scan_in_thread (BaobabScanner* self);
static void baobab_scanner_set_show_allocated_size (BaobabScanner* self,
                                             gboolean value);
static void _vala_array_add5 (BaobabScannerResults** * array,
                       gint* length,
                       gint* size,
                       BaobabScannerResults* value);
static void baobab_scanner_ensure_iter_exists (BaobabScanner* self,
                                        BaobabScannerResults* results);
static void _vala_GtkTreeIter_free (GtkTreeIter* self);
static GtkTreeIter* _vala_GtkTreeIter_copy (GtkTreeIter* self);
static gboolean baobab_scanner_process_results (BaobabScanner* self);
static void baobab_scanner_cancel_and_reset (BaobabScanner* self);
static guint baobab_scanner_hard_link_hash (BaobabScannerHardLink* self);
static guint _baobab_scanner_hard_link_hash_ghash_func (gconstpointer key);
static gboolean baobab_scanner_hard_link_equal (BaobabScannerHardLink* self,
                                         BaobabScannerHardLink* other);
static gboolean _baobab_scanner_hard_link_equal_gequal_func (gconstpointer a,
                                                      gconstpointer b);
static void _baobab_scanner_hard_link_free0_ (gpointer var);
static gpointer _baobab_scanner_scan_in_thread_gthread_func (gpointer self);
static gboolean ___lambda4_ (BaobabScanner* self);
static gboolean ____lambda4__gsource_func (gpointer self);
static void baobab_scanner_set_directory (BaobabScanner* self,
                                   GFile* value);
static void baobab_scanner_set_scan_flags (BaobabScanner* self,
                                    BaobabScanFlags value);
static void _baobab_scanner_results_array_free0_ (gpointer var);
static void baobab_scanner_hard_link_instance_init (BaobabScannerHardLink * self);
static void baobab_scanner_results_array_instance_init (BaobabScannerResultsArray * self);
static void baobab_scanner_results_instance_init (BaobabScannerResults * self);
static void baobab_scanner_finalize (GObject * obj);
static GType baobab_scanner_get_type_once (void);
static void _vala_baobab_scanner_get_property (GObject * object,
                                        guint property_id,
                                        GValue * value,
                                        GParamSpec * pspec);
static void _vala_baobab_scanner_set_property (GObject * object,
                                        guint property_id,
                                        const GValue * value,
                                        GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

static GType
baobab_scan_flags_get_type_once (void)
{
	static const GFlagsValue values[] = {{BAOBAB_SCAN_FLAGS_NONE, "BAOBAB_SCAN_FLAGS_NONE", "none"}, {BAOBAB_SCAN_FLAGS_EXCLUDE_MOUNTS, "BAOBAB_SCAN_FLAGS_EXCLUDE_MOUNTS", "exclude-mounts"}, {0, NULL, NULL}};
	GType baobab_scan_flags_type_id;
	baobab_scan_flags_type_id = g_flags_register_static ("BaobabScanFlags", values);
	return baobab_scan_flags_type_id;
}

GType
baobab_scan_flags_get_type (void)
{
	static volatile gsize baobab_scan_flags_type_id__once = 0;
	if (g_once_init_enter (&baobab_scan_flags_type_id__once)) {
		GType baobab_scan_flags_type_id;
		baobab_scan_flags_type_id = baobab_scan_flags_get_type_once ();
		g_once_init_leave (&baobab_scan_flags_type_id__once, baobab_scan_flags_type_id);
	}
	return baobab_scan_flags_type_id__once;
}

static inline gpointer
baobab_scanner_get_instance_private (BaobabScanner* self)
{
	return G_STRUCT_MEMBER_P (self, BaobabScanner_private_offset);
}

static GType
baobab_scanner_columns_get_type_once (void)
{
	static const GEnumValue values[] = {{BAOBAB_SCANNER_COLUMNS_NAME, "BAOBAB_SCANNER_COLUMNS_NAME", "name"}, {BAOBAB_SCANNER_COLUMNS_PERCENT, "BAOBAB_SCANNER_COLUMNS_PERCENT", "percent"}, {BAOBAB_SCANNER_COLUMNS_SIZE, "BAOBAB_SCANNER_COLUMNS_SIZE", "size"}, {BAOBAB_SCANNER_COLUMNS_TIME_MODIFIED, "BAOBAB_SCANNER_COLUMNS_TIME_MODIFIED", "time-modified"}, {BAOBAB_SCANNER_COLUMNS_DISPLAY_NAME, "BAOBAB_SCANNER_COLUMNS_DISPLAY_NAME", "display-name"}, {BAOBAB_SCANNER_COLUMNS_ELEMENTS, "BAOBAB_SCANNER_COLUMNS_ELEMENTS", "elements"}, {BAOBAB_SCANNER_COLUMNS_STATE, "BAOBAB_SCANNER_COLUMNS_STATE", "state"}, {BAOBAB_SCANNER_COLUMNS_COLUMNS, "BAOBAB_SCANNER_COLUMNS_COLUMNS", "columns"}, {0, NULL, NULL}};
	GType baobab_scanner_columns_type_id;
	baobab_scanner_columns_type_id = g_enum_register_static ("BaobabScannerColumns", values);
	return baobab_scanner_columns_type_id;
}

GType
baobab_scanner_columns_get_type (void)
{
	static volatile gsize baobab_scanner_columns_type_id__once = 0;
	if (g_once_init_enter (&baobab_scanner_columns_type_id__once)) {
		GType baobab_scanner_columns_type_id;
		baobab_scanner_columns_type_id = baobab_scanner_columns_get_type_once ();
		g_once_init_leave (&baobab_scanner_columns_type_id__once, baobab_scanner_columns_type_id);
	}
	return baobab_scanner_columns_type_id__once;
}

static GType
baobab_scanner_state_get_type_once (void)
{
	static const GEnumValue values[] = {{BAOBAB_SCANNER_STATE_SCANNING, "BAOBAB_SCANNER_STATE_SCANNING", "scanning"}, {BAOBAB_SCANNER_STATE_ERROR, "BAOBAB_SCANNER_STATE_ERROR", "error"}, {BAOBAB_SCANNER_STATE_CHILD_ERROR, "BAOBAB_SCANNER_STATE_CHILD_ERROR", "child-error"}, {BAOBAB_SCANNER_STATE_DONE, "BAOBAB_SCANNER_STATE_DONE", "done"}, {0, NULL, NULL}};
	GType baobab_scanner_state_type_id;
	baobab_scanner_state_type_id = g_enum_register_static ("BaobabScannerState", values);
	return baobab_scanner_state_type_id;
}

GType
baobab_scanner_state_get_type (void)
{
	static volatile gsize baobab_scanner_state_type_id__once = 0;
	if (g_once_init_enter (&baobab_scanner_state_type_id__once)) {
		GType baobab_scanner_state_type_id;
		baobab_scanner_state_type_id = baobab_scanner_state_get_type_once ();
		g_once_init_leave (&baobab_scanner_state_type_id__once, baobab_scanner_state_type_id);
	}
	return baobab_scanner_state_type_id__once;
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 75 "../src/baobab-scanner.vala"
	return self ? g_object_ref (self) : NULL;
#line 278 "baobab-scanner.c"
}

static void
_g_free0_ (gpointer var)
{
#line 80 "../src/baobab-scanner.vala"
	var = (g_free (var), NULL);
#line 286 "baobab-scanner.c"
}

static inline void
_g_list_free__g_free0_ (GList* self)
{
#line 80 "../src/baobab-scanner.vala"
	g_list_free_full (self, (GDestroyNotify) _g_free0_);
#line 294 "baobab-scanner.c"
}

GFile*
baobab_scanner_get_file (BaobabScanner* self,
                         GtkTreeIter* iter)
{
	GList* names = NULL;
	GtkTreeIter child = {0};
	GtkTreeIter _tmp0_ = {0};
	GFile* file = NULL;
	GFile* _tmp10_;
	GFile* _tmp11_;
	GList* _tmp12_;
	GList* _tmp13_;
	GFile* result;
#line 64 "../src/baobab-scanner.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 64 "../src/baobab-scanner.vala"
	g_return_val_if_fail (iter != NULL, NULL);
#line 65 "../src/baobab-scanner.vala"
	names = NULL;
#line 66 "../src/baobab-scanner.vala"
	_tmp0_.stamp = 0;
#line 66 "../src/baobab-scanner.vala"
	child = _tmp0_;
#line 320 "baobab-scanner.c"
	{
		gboolean _tmp1_ = FALSE;
#line 68 "../src/baobab-scanner.vala"
		_tmp1_ = TRUE;
#line 68 "../src/baobab-scanner.vala"
		while (TRUE) {
#line 327 "baobab-scanner.c"
			gchar* name = NULL;
			GtkTreeIter _tmp5_;
			gchar* _tmp6_ = NULL;
			const gchar* _tmp7_;
			gchar* _tmp8_;
			GtkTreeIter _tmp9_;
#line 68 "../src/baobab-scanner.vala"
			if (!_tmp1_) {
#line 336 "baobab-scanner.c"
				GtkTreeIter _tmp2_;
				GtkTreeIter _tmp3_ = {0};
				gboolean _tmp4_;
#line 73 "../src/baobab-scanner.vala"
				_tmp2_ = child;
#line 73 "../src/baobab-scanner.vala"
				_tmp4_ = gtk_tree_model_iter_parent ((GtkTreeModel*) self, &_tmp3_, &_tmp2_);
#line 73 "../src/baobab-scanner.vala"
				*iter = _tmp3_;
#line 73 "../src/baobab-scanner.vala"
				if (!_tmp4_) {
#line 73 "../src/baobab-scanner.vala"
					break;
#line 350 "baobab-scanner.c"
				}
			}
#line 68 "../src/baobab-scanner.vala"
			_tmp1_ = FALSE;
#line 70 "../src/baobab-scanner.vala"
			_tmp5_ = *iter;
#line 70 "../src/baobab-scanner.vala"
			gtk_tree_model_get ((GtkTreeModel*) self, &_tmp5_, BAOBAB_SCANNER_COLUMNS_NAME, &_tmp6_, -1);
#line 70 "../src/baobab-scanner.vala"
			_g_free0 (name);
#line 70 "../src/baobab-scanner.vala"
			name = _tmp6_;
#line 71 "../src/baobab-scanner.vala"
			_tmp7_ = name;
#line 71 "../src/baobab-scanner.vala"
			_tmp8_ = g_strdup (_tmp7_);
#line 71 "../src/baobab-scanner.vala"
			names = g_list_prepend (names, _tmp8_);
#line 72 "../src/baobab-scanner.vala"
			_tmp9_ = *iter;
#line 72 "../src/baobab-scanner.vala"
			child = _tmp9_;
#line 68 "../src/baobab-scanner.vala"
			_g_free0 (name);
#line 375 "baobab-scanner.c"
		}
	}
#line 75 "../src/baobab-scanner.vala"
	_tmp10_ = self->priv->_directory;
#line 75 "../src/baobab-scanner.vala"
	_tmp11_ = _g_object_ref0 (_tmp10_);
#line 75 "../src/baobab-scanner.vala"
	file = _tmp11_;
#line 76 "../src/baobab-scanner.vala"
	_tmp12_ = names;
#line 76 "../src/baobab-scanner.vala"
	_tmp13_ = _tmp12_->next;
#line 388 "baobab-scanner.c"
	{
		GList* name_collection = NULL;
		GList* name_it = NULL;
#line 76 "../src/baobab-scanner.vala"
		name_collection = _tmp13_;
#line 76 "../src/baobab-scanner.vala"
		for (name_it = name_collection; name_it != NULL; name_it = name_it->next) {
#line 396 "baobab-scanner.c"
			gchar* _tmp14_;
			gchar* name = NULL;
#line 76 "../src/baobab-scanner.vala"
			_tmp14_ = g_strdup ((const gchar*) name_it->data);
#line 76 "../src/baobab-scanner.vala"
			name = _tmp14_;
#line 403 "baobab-scanner.c"
			{
				GFile* _tmp15_;
				const gchar* _tmp16_;
				GFile* _tmp17_;
#line 77 "../src/baobab-scanner.vala"
				_tmp15_ = file;
#line 77 "../src/baobab-scanner.vala"
				_tmp16_ = name;
#line 77 "../src/baobab-scanner.vala"
				_tmp17_ = g_file_get_child (_tmp15_, _tmp16_);
#line 77 "../src/baobab-scanner.vala"
				_g_object_unref0 (file);
#line 77 "../src/baobab-scanner.vala"
				file = _tmp17_;
#line 76 "../src/baobab-scanner.vala"
				_g_free0 (name);
#line 420 "baobab-scanner.c"
			}
		}
	}
#line 80 "../src/baobab-scanner.vala"
	result = file;
#line 80 "../src/baobab-scanner.vala"
	(names == NULL) ? NULL : (names = (_g_list_free__g_free0_ (names), NULL));
#line 80 "../src/baobab-scanner.vala"
	return result;
#line 430 "baobab-scanner.c"
}

static void
_vala_array_add3 (BaobabScannerResults** * array,
                  gint* length,
                  gint* size,
                  BaobabScannerResults* value)
{
#line 230 "../src/baobab-scanner.vala"
	if ((*length) == (*size)) {
#line 230 "../src/baobab-scanner.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 230 "../src/baobab-scanner.vala"
		*array = g_renew (BaobabScannerResults*, *array, (*size) + 1);
#line 445 "baobab-scanner.c"
	}
#line 230 "../src/baobab-scanner.vala"
	(*array)[(*length)++] = value;
#line 230 "../src/baobab-scanner.vala"
	(*array)[*length] = NULL;
#line 451 "baobab-scanner.c"
}

static void
_vala_array_add4 (BaobabScannerResults** * array,
                  gint* length,
                  gint* size,
                  BaobabScannerResults* value)
{
#line 253 "../src/baobab-scanner.vala"
	if ((*length) == (*size)) {
#line 253 "../src/baobab-scanner.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 253 "../src/baobab-scanner.vala"
		*array = g_renew (BaobabScannerResults*, *array, (*size) + 1);
#line 466 "baobab-scanner.c"
	}
#line 253 "../src/baobab-scanner.vala"
	(*array)[(*length)++] = value;
#line 253 "../src/baobab-scanner.vala"
	(*array)[*length] = NULL;
#line 472 "baobab-scanner.c"
}

static void
baobab_scanner_add_children (BaobabScanner* self,
                             GFile* directory,
                             BaobabScannerResults* results,
                             BaobabScannerResultsArray* results_array,
                             GError** error)
{
	GFileEnumerator* children = NULL;
	GCancellable* _tmp0_;
	GFileEnumerator* _tmp1_;
	GFileInfo* child_info = NULL;
	GError* _inner_error0_ = NULL;
#line 219 "../src/baobab-scanner.vala"
	g_return_if_fail (self != NULL);
#line 219 "../src/baobab-scanner.vala"
	g_return_if_fail (directory != NULL);
#line 219 "../src/baobab-scanner.vala"
	g_return_if_fail (results != NULL);
#line 219 "../src/baobab-scanner.vala"
	g_return_if_fail (results_array != NULL);
#line 220 "../src/baobab-scanner.vala"
	_tmp0_ = self->priv->cancellable;
#line 220 "../src/baobab-scanner.vala"
	_tmp1_ = g_file_enumerate_children (directory, BAOBAB_SCANNER_ATTRIBUTES, G_FILE_QUERY_INFO_NOFOLLOW_SYMLINKS, _tmp0_, &_inner_error0_);
#line 220 "../src/baobab-scanner.vala"
	children = _tmp1_;
#line 220 "../src/baobab-scanner.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 220 "../src/baobab-scanner.vala"
		g_propagate_error (error, _inner_error0_);
#line 220 "../src/baobab-scanner.vala"
		return;
#line 507 "baobab-scanner.c"
	}
#line 222 "../src/baobab-scanner.vala"
	while (TRUE) {
#line 511 "baobab-scanner.c"
		GFileInfo* _tmp2_ = NULL;
		GFileEnumerator* _tmp3_;
		GCancellable* _tmp4_;
		GFileInfo* _tmp5_;
		GFileInfo* _tmp6_;
		GFileInfo* _tmp7_;
		GFileInfo* _tmp8_;
#line 222 "../src/baobab-scanner.vala"
		_tmp3_ = children;
#line 222 "../src/baobab-scanner.vala"
		_tmp4_ = self->priv->cancellable;
#line 222 "../src/baobab-scanner.vala"
		_tmp5_ = g_file_enumerator_next_file (_tmp3_, _tmp4_, &_inner_error0_);
#line 222 "../src/baobab-scanner.vala"
		_tmp2_ = _tmp5_;
#line 222 "../src/baobab-scanner.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 222 "../src/baobab-scanner.vala"
			g_propagate_error (error, _inner_error0_);
#line 222 "../src/baobab-scanner.vala"
			_g_object_unref0 (child_info);
#line 222 "../src/baobab-scanner.vala"
			_g_object_unref0 (children);
#line 222 "../src/baobab-scanner.vala"
			return;
#line 537 "baobab-scanner.c"
		}
#line 222 "../src/baobab-scanner.vala"
		_tmp6_ = _tmp2_;
#line 222 "../src/baobab-scanner.vala"
		_tmp2_ = NULL;
#line 222 "../src/baobab-scanner.vala"
		_g_object_unref0 (child_info);
#line 222 "../src/baobab-scanner.vala"
		child_info = _tmp6_;
#line 222 "../src/baobab-scanner.vala"
		_tmp7_ = child_info;
#line 222 "../src/baobab-scanner.vala"
		if (!(_tmp7_ != NULL)) {
#line 222 "../src/baobab-scanner.vala"
			_g_object_unref0 (_tmp2_);
#line 222 "../src/baobab-scanner.vala"
			break;
#line 555 "baobab-scanner.c"
		}
#line 223 "../src/baobab-scanner.vala"
		_tmp8_ = child_info;
#line 223 "../src/baobab-scanner.vala"
		switch (g_file_info_get_file_type (_tmp8_)) {
#line 223 "../src/baobab-scanner.vala"
			case G_FILE_TYPE_DIRECTORY:
#line 563 "baobab-scanner.c"
			{
				GFile* child = NULL;
				GFileInfo* _tmp9_;
				const gchar* _tmp10_;
				GFile* _tmp11_;
				BaobabScannerResults* child_results = NULL;
				GFile* _tmp12_;
				GFileInfo* _tmp13_;
				BaobabScannerResults* _tmp14_;
				BaobabScannerResults* _tmp15_;
#line 225 "../src/baobab-scanner.vala"
				_tmp9_ = child_info;
#line 225 "../src/baobab-scanner.vala"
				_tmp10_ = g_file_info_get_name (_tmp9_);
#line 225 "../src/baobab-scanner.vala"
				_tmp11_ = g_file_get_child (directory, _tmp10_);
#line 225 "../src/baobab-scanner.vala"
				child = _tmp11_;
#line 226 "../src/baobab-scanner.vala"
				_tmp12_ = child;
#line 226 "../src/baobab-scanner.vala"
				_tmp13_ = child_info;
#line 226 "../src/baobab-scanner.vala"
				_tmp14_ = baobab_scanner_add_directory (self, _tmp12_, _tmp13_, results);
#line 226 "../src/baobab-scanner.vala"
				child_results = _tmp14_;
#line 228 "../src/baobab-scanner.vala"
				_tmp15_ = child_results;
#line 228 "../src/baobab-scanner.vala"
				if (_tmp15_ != NULL) {
#line 594 "baobab-scanner.c"
					BaobabScannerResults* _tmp16_;
					BaobabScannerResults* _tmp17_;
#line 229 "../src/baobab-scanner.vala"
					_tmp16_ = child_results;
#line 229 "../src/baobab-scanner.vala"
					baobab_scanner_results_update_with_child (results, _tmp16_);
#line 230 "../src/baobab-scanner.vala"
					_tmp17_ = child_results;
#line 230 "../src/baobab-scanner.vala"
					child_results = NULL;
#line 230 "../src/baobab-scanner.vala"
					_vala_array_add3 (&results_array->results, &results_array->results_length1, &results_array->_results_size_, _tmp17_);
#line 607 "baobab-scanner.c"
				}
#line 232 "../src/baobab-scanner.vala"
				_baobab_scanner_results_free0 (child_results);
#line 232 "../src/baobab-scanner.vala"
				_g_object_unref0 (child);
#line 232 "../src/baobab-scanner.vala"
				break;
#line 615 "baobab-scanner.c"
			}
#line 223 "../src/baobab-scanner.vala"
			case G_FILE_TYPE_REGULAR:
#line 619 "baobab-scanner.c"
			{
				GFileInfo* _tmp18_;
				BaobabScannerResults* child_results = NULL;
				GFileInfo* _tmp26_;
				BaobabScannerResults* _tmp27_;
				guint64 _tmp28_;
				BaobabScannerResults* _tmp29_;
				gint _tmp30_;
				BaobabScannerResults* _tmp31_;
				BaobabScannerResults* _tmp32_;
#line 235 "../src/baobab-scanner.vala"
				_tmp18_ = child_info;
#line 235 "../src/baobab-scanner.vala"
				if (g_file_info_has_attribute (_tmp18_, G_FILE_ATTRIBUTE_UNIX_NLINK)) {
#line 634 "baobab-scanner.c"
					GFileInfo* _tmp19_;
#line 236 "../src/baobab-scanner.vala"
					_tmp19_ = child_info;
#line 236 "../src/baobab-scanner.vala"
					if (g_file_info_get_attribute_uint32 (_tmp19_, G_FILE_ATTRIBUTE_UNIX_NLINK) > ((guint32) 1)) {
#line 640 "baobab-scanner.c"
						BaobabScannerHardLink* hl = NULL;
						GFileInfo* _tmp20_;
						BaobabScannerHardLink* _tmp21_;
						GHashTable* _tmp22_;
						BaobabScannerHardLink* _tmp23_;
						GHashTable* _tmp24_;
						BaobabScannerHardLink* _tmp25_;
#line 237 "../src/baobab-scanner.vala"
						_tmp20_ = child_info;
#line 237 "../src/baobab-scanner.vala"
						_tmp21_ = baobab_scanner_hard_link_new (_tmp20_);
#line 237 "../src/baobab-scanner.vala"
						hl = _tmp21_;
#line 240 "../src/baobab-scanner.vala"
						_tmp22_ = self->priv->hardlinks;
#line 240 "../src/baobab-scanner.vala"
						_tmp23_ = hl;
#line 240 "../src/baobab-scanner.vala"
						if (g_hash_table_contains (_tmp22_, _tmp23_)) {
#line 241 "../src/baobab-scanner.vala"
							_baobab_scanner_hard_link_free0 (hl);
#line 241 "../src/baobab-scanner.vala"
							_g_object_unref0 (_tmp2_);
#line 241 "../src/baobab-scanner.vala"
							continue;
#line 666 "baobab-scanner.c"
						}
#line 244 "../src/baobab-scanner.vala"
						_tmp24_ = self->priv->hardlinks;
#line 244 "../src/baobab-scanner.vala"
						_tmp25_ = hl;
#line 244 "../src/baobab-scanner.vala"
						hl = NULL;
#line 244 "../src/baobab-scanner.vala"
						g_hash_table_add (_tmp24_, _tmp25_);
#line 236 "../src/baobab-scanner.vala"
						_baobab_scanner_hard_link_free0 (hl);
#line 678 "baobab-scanner.c"
					}
				}
#line 249 "../src/baobab-scanner.vala"
				_tmp26_ = child_info;
#line 249 "../src/baobab-scanner.vala"
				_tmp27_ = baobab_scanner_results_new (_tmp26_, results);
#line 249 "../src/baobab-scanner.vala"
				child_results = _tmp27_;
#line 250 "../src/baobab-scanner.vala"
				_tmp28_ = self->priv->_total_size;
#line 250 "../src/baobab-scanner.vala"
				_tmp29_ = child_results;
#line 250 "../src/baobab-scanner.vala"
				baobab_scanner_set_total_size (self, _tmp28_ + _tmp29_->size);
#line 251 "../src/baobab-scanner.vala"
				_tmp30_ = self->priv->_total_elements;
#line 251 "../src/baobab-scanner.vala"
				baobab_scanner_set_total_elements (self, _tmp30_ + 1);
#line 252 "../src/baobab-scanner.vala"
				_tmp31_ = child_results;
#line 252 "../src/baobab-scanner.vala"
				baobab_scanner_results_update_with_child (results, _tmp31_);
#line 253 "../src/baobab-scanner.vala"
				_tmp32_ = child_results;
#line 253 "../src/baobab-scanner.vala"
				child_results = NULL;
#line 253 "../src/baobab-scanner.vala"
				_vala_array_add4 (&results_array->results, &results_array->results_length1, &results_array->_results_size_, _tmp32_);
#line 254 "../src/baobab-scanner.vala"
				_baobab_scanner_results_free0 (child_results);
#line 254 "../src/baobab-scanner.vala"
				break;
#line 711 "baobab-scanner.c"
			}
			default:
			{
#line 258 "../src/baobab-scanner.vala"
				break;
#line 717 "baobab-scanner.c"
			}
		}
#line 222 "../src/baobab-scanner.vala"
		_g_object_unref0 (_tmp2_);
#line 722 "baobab-scanner.c"
	}
#line 219 "../src/baobab-scanner.vala"
	_g_object_unref0 (child_info);
#line 219 "../src/baobab-scanner.vala"
	_g_object_unref0 (children);
#line 728 "baobab-scanner.c"
}

static gpointer
_g_error_copy0 (gpointer self)
{
#line 283 "../src/baobab-scanner.vala"
	return self ? g_error_copy (self) : NULL;
#line 736 "baobab-scanner.c"
}

static BaobabScannerResults*
baobab_scanner_add_directory (BaobabScanner* self,
                              GFile* directory,
                              GFileInfo* info,
                              BaobabScannerResults* parent)
{
	BaobabScannerResultsArray* results_array = NULL;
	BaobabScannerResultsArray* _tmp0_;
	guint32 current_unix_device = 0U;
	gboolean _tmp1_ = FALSE;
	BaobabScanFlags _tmp2_;
	BaobabScannerResults* results = NULL;
	BaobabScannerResults* _tmp3_;
	GHashTable* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gboolean _tmp7_;
	guint64 _tmp10_;
	BaobabScannerResults* _tmp11_;
	gint _tmp12_;
	BaobabScannerResultsArray* _tmp18_;
	BaobabScannerResults** _tmp19_;
	gint _tmp19__length1;
	GAsyncQueue* _tmp25_;
	BaobabScannerResultsArray* _tmp26_;
	GError* _inner_error0_ = NULL;
	BaobabScannerResults* result;
#line 263 "../src/baobab-scanner.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 263 "../src/baobab-scanner.vala"
	g_return_val_if_fail (directory != NULL, NULL);
#line 263 "../src/baobab-scanner.vala"
	g_return_val_if_fail (info != NULL, NULL);
#line 264 "../src/baobab-scanner.vala"
	_tmp0_ = baobab_scanner_results_array_new ();
#line 264 "../src/baobab-scanner.vala"
	results_array = _tmp0_;
#line 266 "../src/baobab-scanner.vala"
	current_unix_device = g_file_info_get_attribute_uint32 (info, G_FILE_ATTRIBUTE_UNIX_DEVICE);
#line 267 "../src/baobab-scanner.vala"
	_tmp2_ = self->priv->_scan_flags;
#line 267 "../src/baobab-scanner.vala"
	if ((_tmp2_ & BAOBAB_SCAN_FLAGS_EXCLUDE_MOUNTS) == BAOBAB_SCAN_FLAGS_EXCLUDE_MOUNTS) {
#line 267 "../src/baobab-scanner.vala"
		_tmp1_ = current_unix_device != self->priv->unix_device;
#line 784 "baobab-scanner.c"
	} else {
#line 267 "../src/baobab-scanner.vala"
		_tmp1_ = FALSE;
#line 788 "baobab-scanner.c"
	}
#line 267 "../src/baobab-scanner.vala"
	if (_tmp1_) {
#line 268 "../src/baobab-scanner.vala"
		result = NULL;
#line 268 "../src/baobab-scanner.vala"
		_baobab_scanner_results_array_free0 (results_array);
#line 268 "../src/baobab-scanner.vala"
		return result;
#line 798 "baobab-scanner.c"
	}
#line 271 "../src/baobab-scanner.vala"
	_tmp3_ = baobab_scanner_results_new (info, parent);
#line 271 "../src/baobab-scanner.vala"
	results = _tmp3_;
#line 272 "../src/baobab-scanner.vala"
	_tmp4_ = self->priv->excluded_locations;
#line 272 "../src/baobab-scanner.vala"
	_tmp5_ = g_file_get_uri (directory);
#line 272 "../src/baobab-scanner.vala"
	_tmp6_ = _tmp5_;
#line 272 "../src/baobab-scanner.vala"
	_tmp7_ = g_hash_table_contains (_tmp4_, _tmp6_);
#line 272 "../src/baobab-scanner.vala"
	_g_free0 (_tmp6_);
#line 272 "../src/baobab-scanner.vala"
	if (_tmp7_) {
#line 816 "baobab-scanner.c"
		BaobabScannerResults* _tmp8_;
		GError* _tmp9_;
#line 273 "../src/baobab-scanner.vala"
		_tmp8_ = results;
#line 273 "../src/baobab-scanner.vala"
		_tmp9_ = g_error_new_literal (G_IO_ERROR, G_IO_ERROR_FAILED, "Location is excluded");
#line 273 "../src/baobab-scanner.vala"
		_g_error_free0 (_tmp8_->error);
#line 273 "../src/baobab-scanner.vala"
		_tmp8_->error = _tmp9_;
#line 274 "../src/baobab-scanner.vala"
		result = results;
#line 274 "../src/baobab-scanner.vala"
		_baobab_scanner_results_array_free0 (results_array);
#line 274 "../src/baobab-scanner.vala"
		return result;
#line 833 "baobab-scanner.c"
	}
#line 277 "../src/baobab-scanner.vala"
	_tmp10_ = self->priv->_total_size;
#line 277 "../src/baobab-scanner.vala"
	_tmp11_ = results;
#line 277 "../src/baobab-scanner.vala"
	baobab_scanner_set_total_size (self, _tmp10_ + _tmp11_->size);
#line 278 "../src/baobab-scanner.vala"
	_tmp12_ = self->priv->_total_elements;
#line 278 "../src/baobab-scanner.vala"
	baobab_scanner_set_total_elements (self, _tmp12_ + 1);
#line 845 "baobab-scanner.c"
	{
		BaobabScannerResults* _tmp13_;
		BaobabScannerResultsArray* _tmp14_;
#line 281 "../src/baobab-scanner.vala"
		_tmp13_ = results;
#line 281 "../src/baobab-scanner.vala"
		_tmp14_ = results_array;
#line 281 "../src/baobab-scanner.vala"
		baobab_scanner_add_children (self, directory, _tmp13_, _tmp14_, &_inner_error0_);
#line 281 "../src/baobab-scanner.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 857 "baobab-scanner.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		BaobabScannerResults* _tmp15_;
		GError* _tmp16_;
		GError* _tmp17_;
#line 280 "../src/baobab-scanner.vala"
		e = _inner_error0_;
#line 280 "../src/baobab-scanner.vala"
		_inner_error0_ = NULL;
#line 283 "../src/baobab-scanner.vala"
		_tmp15_ = results;
#line 283 "../src/baobab-scanner.vala"
		_tmp16_ = e;
#line 283 "../src/baobab-scanner.vala"
		_tmp17_ = _g_error_copy0 (_tmp16_);
#line 283 "../src/baobab-scanner.vala"
		_g_error_free0 (_tmp15_->error);
#line 283 "../src/baobab-scanner.vala"
		_tmp15_->error = _tmp17_;
#line 280 "../src/baobab-scanner.vala"
		_g_error_free0 (e);
#line 884 "baobab-scanner.c"
	}
	__finally0:
#line 280 "../src/baobab-scanner.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 280 "../src/baobab-scanner.vala"
		_baobab_scanner_results_free0 (results);
#line 280 "../src/baobab-scanner.vala"
		_baobab_scanner_results_array_free0 (results_array);
#line 280 "../src/baobab-scanner.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 280 "../src/baobab-scanner.vala"
		g_clear_error (&_inner_error0_);
#line 280 "../src/baobab-scanner.vala"
		return NULL;
#line 899 "baobab-scanner.c"
	}
#line 286 "../src/baobab-scanner.vala"
	_tmp18_ = results_array;
#line 286 "../src/baobab-scanner.vala"
	_tmp19_ = _tmp18_->results;
#line 286 "../src/baobab-scanner.vala"
	_tmp19__length1 = _tmp18_->results_length1;
#line 907 "baobab-scanner.c"
	{
		BaobabScannerResults** child_results_collection = NULL;
		gint child_results_collection_length1 = 0;
		gint _child_results_collection_size_ = 0;
		gint child_results_it = 0;
#line 286 "../src/baobab-scanner.vala"
		child_results_collection = _tmp19_;
#line 286 "../src/baobab-scanner.vala"
		child_results_collection_length1 = _tmp19__length1;
#line 286 "../src/baobab-scanner.vala"
		for (child_results_it = 0; child_results_it < child_results_collection_length1; child_results_it = child_results_it + 1) {
#line 919 "baobab-scanner.c"
			BaobabScannerResults* child_results = NULL;
#line 286 "../src/baobab-scanner.vala"
			child_results = child_results_collection[child_results_it];
#line 923 "baobab-scanner.c"
			{
				BaobabScannerResults* _tmp20_;
#line 287 "../src/baobab-scanner.vala"
				_tmp20_ = results;
#line 287 "../src/baobab-scanner.vala"
				if (_tmp20_->size > ((guint64) 0)) {
#line 930 "baobab-scanner.c"
					BaobabScannerResults* _tmp21_;
					BaobabScannerResults* _tmp22_;
					BaobabScannerResults* _tmp23_;
#line 288 "../src/baobab-scanner.vala"
					_tmp21_ = child_results;
#line 288 "../src/baobab-scanner.vala"
					_tmp22_ = child_results;
#line 288 "../src/baobab-scanner.vala"
					_tmp23_ = results;
#line 288 "../src/baobab-scanner.vala"
					_tmp21_->percent = (100 * ((gdouble) _tmp22_->size)) / ((gdouble) _tmp23_->size);
#line 942 "baobab-scanner.c"
				} else {
					BaobabScannerResults* _tmp24_;
#line 290 "../src/baobab-scanner.vala"
					_tmp24_ = child_results;
#line 290 "../src/baobab-scanner.vala"
					_tmp24_->percent = (gdouble) 0;
#line 949 "baobab-scanner.c"
				}
			}
		}
	}
#line 297 "../src/baobab-scanner.vala"
	_tmp25_ = self->priv->results_queue;
#line 297 "../src/baobab-scanner.vala"
	_tmp26_ = results_array;
#line 297 "../src/baobab-scanner.vala"
	results_array = NULL;
#line 297 "../src/baobab-scanner.vala"
	g_async_queue_push (_tmp25_, _tmp26_);
#line 299 "../src/baobab-scanner.vala"
	result = results;
#line 299 "../src/baobab-scanner.vala"
	_baobab_scanner_results_array_free0 (results_array);
#line 299 "../src/baobab-scanner.vala"
	return result;
#line 968 "baobab-scanner.c"
}

static void
_vala_array_add5 (BaobabScannerResults** * array,
                  gint* length,
                  gint* size,
                  BaobabScannerResults* value)
{
#line 314 "../src/baobab-scanner.vala"
	if ((*length) == (*size)) {
#line 314 "../src/baobab-scanner.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 314 "../src/baobab-scanner.vala"
		*array = g_renew (BaobabScannerResults*, *array, (*size) + 1);
#line 983 "baobab-scanner.c"
	}
#line 314 "../src/baobab-scanner.vala"
	(*array)[(*length)++] = value;
#line 314 "../src/baobab-scanner.vala"
	(*array)[*length] = NULL;
#line 989 "baobab-scanner.c"
}

static void*
baobab_scanner_scan_in_thread (BaobabScanner* self)
{
	GError* _inner_error0_ = NULL;
	void* result;
#line 302 "../src/baobab-scanner.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 999 "baobab-scanner.c"
	{
		BaobabScannerResultsArray* array = NULL;
		BaobabScannerResultsArray* _tmp0_;
		GFileInfo* info = NULL;
		GFile* _tmp1_;
		GCancellable* _tmp2_;
		GFileInfo* _tmp3_;
		BaobabScannerResults* results = NULL;
		GFile* _tmp4_;
		BaobabScannerResults* _tmp5_;
		BaobabScannerResults* _tmp6_;
		BaobabScannerResultsArray* _tmp7_;
		BaobabScannerResultsArray* _tmp8_;
		BaobabScannerResults* _tmp9_;
		GAsyncQueue* _tmp10_;
		BaobabScannerResultsArray* _tmp11_;
#line 304 "../src/baobab-scanner.vala"
		_tmp0_ = baobab_scanner_results_array_new ();
#line 304 "../src/baobab-scanner.vala"
		array = _tmp0_;
#line 305 "../src/baobab-scanner.vala"
		_tmp1_ = self->priv->_directory;
#line 305 "../src/baobab-scanner.vala"
		_tmp2_ = self->priv->cancellable;
#line 305 "../src/baobab-scanner.vala"
		_tmp3_ = g_file_query_info (_tmp1_, BAOBAB_SCANNER_ATTRIBUTES, 0, _tmp2_, &_inner_error0_);
#line 305 "../src/baobab-scanner.vala"
		info = _tmp3_;
#line 305 "../src/baobab-scanner.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 305 "../src/baobab-scanner.vala"
			_baobab_scanner_results_array_free0 (array);
#line 1032 "baobab-scanner.c"
			goto __catch0_g_error;
		}
#line 309 "../src/baobab-scanner.vala"
		baobab_scanner_set_show_allocated_size (self, g_file_info_get_attribute_uint64 (info, G_FILE_ATTRIBUTE_STANDARD_ALLOCATED_SIZE) > ((guint64) 0));
#line 311 "../src/baobab-scanner.vala"
		self->priv->unix_device = g_file_info_get_attribute_uint32 (info, G_FILE_ATTRIBUTE_UNIX_DEVICE);
#line 312 "../src/baobab-scanner.vala"
		_tmp4_ = self->priv->_directory;
#line 312 "../src/baobab-scanner.vala"
		_tmp5_ = baobab_scanner_add_directory (self, _tmp4_, info, NULL);
#line 312 "../src/baobab-scanner.vala"
		results = _tmp5_;
#line 313 "../src/baobab-scanner.vala"
		_tmp6_ = results;
#line 313 "../src/baobab-scanner.vala"
		_tmp6_->percent = 100.0;
#line 314 "../src/baobab-scanner.vala"
		_tmp7_ = array;
#line 314 "../src/baobab-scanner.vala"
		_tmp8_ = array;
#line 314 "../src/baobab-scanner.vala"
		_tmp9_ = results;
#line 314 "../src/baobab-scanner.vala"
		results = NULL;
#line 314 "../src/baobab-scanner.vala"
		_vala_array_add5 (&_tmp7_->results, &_tmp7_->results_length1, &_tmp7_->_results_size_, _tmp9_);
#line 315 "../src/baobab-scanner.vala"
		_tmp10_ = self->priv->results_queue;
#line 315 "../src/baobab-scanner.vala"
		_tmp11_ = array;
#line 315 "../src/baobab-scanner.vala"
		array = NULL;
#line 315 "../src/baobab-scanner.vala"
		g_async_queue_push (_tmp10_, _tmp11_);
#line 303 "../src/baobab-scanner.vala"
		_baobab_scanner_results_free0 (results);
#line 303 "../src/baobab-scanner.vala"
		_g_object_unref0 (info);
#line 303 "../src/baobab-scanner.vala"
		_baobab_scanner_results_array_free0 (array);
#line 1073 "baobab-scanner.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 303 "../src/baobab-scanner.vala"
		g_clear_error (&_inner_error0_);
#line 1080 "baobab-scanner.c"
	}
	__finally0:
#line 303 "../src/baobab-scanner.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 303 "../src/baobab-scanner.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 303 "../src/baobab-scanner.vala"
		g_clear_error (&_inner_error0_);
#line 303 "../src/baobab-scanner.vala"
		return NULL;
#line 1091 "baobab-scanner.c"
	}
#line 320 "../src/baobab-scanner.vala"
	_g_object_unref0 (self->priv->self);
#line 320 "../src/baobab-scanner.vala"
	self->priv->self = NULL;
#line 321 "../src/baobab-scanner.vala"
	result = NULL;
#line 321 "../src/baobab-scanner.vala"
	return result;
#line 1101 "baobab-scanner.c"
}

static void
_vala_GtkTreeIter_free (GtkTreeIter* self)
{
#line 328 "../src/baobab-scanner.vala"
	g_boxed_free (gtk_tree_iter_get_type (), self);
#line 1109 "baobab-scanner.c"
}

static GtkTreeIter*
_vala_GtkTreeIter_copy (GtkTreeIter* self)
{
#line 333 "../src/baobab-scanner.vala"
	return g_boxed_copy (gtk_tree_iter_get_type (), self);
#line 1117 "baobab-scanner.c"
}

static gpointer
__vala_GtkTreeIter_copy0 (gpointer self)
{
#line 333 "../src/baobab-scanner.vala"
	return self ? _vala_GtkTreeIter_copy (self) : NULL;
#line 1125 "baobab-scanner.c"
}

static void
baobab_scanner_ensure_iter_exists (BaobabScanner* self,
                                   BaobabScannerResults* results)
{
	GtkTreeIter* parent_iter = NULL;
	BaobabScannerResults* _tmp0_;
	GtkTreeIter* _tmp5_;
	GtkTreeIter _tmp6_ = {0};
	GtkTreeIter _tmp7_;
	const gchar* _tmp8_;
	const gchar* _tmp9_;
#line 324 "../src/baobab-scanner.vala"
	g_return_if_fail (self != NULL);
#line 324 "../src/baobab-scanner.vala"
	g_return_if_fail (results != NULL);
#line 327 "../src/baobab-scanner.vala"
	if (results->iter_is_set) {
#line 328 "../src/baobab-scanner.vala"
		__vala_GtkTreeIter_free0 (parent_iter);
#line 328 "../src/baobab-scanner.vala"
		return;
#line 1149 "baobab-scanner.c"
	}
#line 331 "../src/baobab-scanner.vala"
	_tmp0_ = results->parent;
#line 331 "../src/baobab-scanner.vala"
	if (_tmp0_ != NULL) {
#line 1155 "baobab-scanner.c"
		BaobabScannerResults* _tmp1_;
		BaobabScannerResults* _tmp2_;
		GtkTreeIter _tmp3_;
		GtkTreeIter* _tmp4_;
#line 332 "../src/baobab-scanner.vala"
		_tmp1_ = results->parent;
#line 332 "../src/baobab-scanner.vala"
		baobab_scanner_ensure_iter_exists (self, _tmp1_);
#line 333 "../src/baobab-scanner.vala"
		_tmp2_ = results->parent;
#line 333 "../src/baobab-scanner.vala"
		_tmp3_ = _tmp2_->iter;
#line 333 "../src/baobab-scanner.vala"
		_tmp4_ = __vala_GtkTreeIter_copy0 (&_tmp3_);
#line 333 "../src/baobab-scanner.vala"
		__vala_GtkTreeIter_free0 (parent_iter);
#line 333 "../src/baobab-scanner.vala"
		parent_iter = _tmp4_;
#line 1174 "baobab-scanner.c"
	} else {
#line 335 "../src/baobab-scanner.vala"
		__vala_GtkTreeIter_free0 (parent_iter);
#line 335 "../src/baobab-scanner.vala"
		parent_iter = NULL;
#line 1180 "baobab-scanner.c"
	}
#line 338 "../src/baobab-scanner.vala"
	_tmp5_ = parent_iter;
#line 338 "../src/baobab-scanner.vala"
	gtk_tree_store_prepend ((GtkTreeStore*) self, &_tmp6_, _tmp5_);
#line 338 "../src/baobab-scanner.vala"
	results->iter = _tmp6_;
#line 339 "../src/baobab-scanner.vala"
	_tmp7_ = results->iter;
#line 339 "../src/baobab-scanner.vala"
	_tmp8_ = results->name;
#line 339 "../src/baobab-scanner.vala"
	gtk_tree_store_set ((GtkTreeStore*) self, &_tmp7_, BAOBAB_SCANNER_COLUMNS_NAME, _tmp8_, -1);
#line 342 "../src/baobab-scanner.vala"
	_tmp9_ = results->display_name;
#line 342 "../src/baobab-scanner.vala"
	if (_tmp9_ != NULL) {
#line 1198 "baobab-scanner.c"
		GtkTreeIter _tmp10_;
		const gchar* _tmp11_;
#line 343 "../src/baobab-scanner.vala"
		_tmp10_ = results->iter;
#line 343 "../src/baobab-scanner.vala"
		_tmp11_ = results->display_name;
#line 343 "../src/baobab-scanner.vala"
		gtk_tree_store_set ((GtkTreeStore*) self, &_tmp10_, BAOBAB_SCANNER_COLUMNS_DISPLAY_NAME, _tmp11_, -1);
#line 1207 "baobab-scanner.c"
	}
#line 345 "../src/baobab-scanner.vala"
	if (results->file_type == G_FILE_TYPE_DIRECTORY) {
#line 1211 "baobab-scanner.c"
		GtkTreeIter _tmp12_;
#line 346 "../src/baobab-scanner.vala"
		_tmp12_ = results->iter;
#line 346 "../src/baobab-scanner.vala"
		gtk_tree_store_set ((GtkTreeStore*) self, &_tmp12_, BAOBAB_SCANNER_COLUMNS_STATE, BAOBAB_SCANNER_STATE_SCANNING, -1);
#line 1217 "baobab-scanner.c"
	}
#line 349 "../src/baobab-scanner.vala"
	results->iter_is_set = TRUE;
#line 324 "../src/baobab-scanner.vala"
	__vala_GtkTreeIter_free0 (parent_iter);
#line 1223 "baobab-scanner.c"
}

static gboolean
baobab_scanner_process_results (BaobabScanner* self)
{
	BaobabScanner* _tmp26_;
	gboolean result;
#line 352 "../src/baobab-scanner.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 353 "../src/baobab-scanner.vala"
	while (TRUE) {
#line 1235 "baobab-scanner.c"
		BaobabScannerResultsArray* results_array = NULL;
		GAsyncQueue* _tmp0_;
		gpointer _tmp1_;
		BaobabScannerResultsArray* _tmp2_;
		BaobabScannerResultsArray* _tmp3_;
		BaobabScannerResults** _tmp4_;
		gint _tmp4__length1;
#line 354 "../src/baobab-scanner.vala"
		_tmp0_ = self->priv->results_queue;
#line 354 "../src/baobab-scanner.vala"
		_tmp1_ = g_async_queue_try_pop (_tmp0_);
#line 354 "../src/baobab-scanner.vala"
		results_array = (BaobabScannerResultsArray*) _tmp1_;
#line 356 "../src/baobab-scanner.vala"
		_tmp2_ = results_array;
#line 356 "../src/baobab-scanner.vala"
		if (_tmp2_ == NULL) {
#line 357 "../src/baobab-scanner.vala"
			_baobab_scanner_results_array_free0 (results_array);
#line 357 "../src/baobab-scanner.vala"
			break;
#line 1257 "baobab-scanner.c"
		}
#line 360 "../src/baobab-scanner.vala"
		_tmp3_ = results_array;
#line 360 "../src/baobab-scanner.vala"
		_tmp4_ = _tmp3_->results;
#line 360 "../src/baobab-scanner.vala"
		_tmp4__length1 = _tmp3_->results_length1;
#line 1265 "baobab-scanner.c"
		{
			BaobabScannerResults** results_collection = NULL;
			gint results_collection_length1 = 0;
			gint _results_collection_size_ = 0;
			gint results_it = 0;
#line 360 "../src/baobab-scanner.vala"
			results_collection = _tmp4_;
#line 360 "../src/baobab-scanner.vala"
			results_collection_length1 = _tmp4__length1;
#line 360 "../src/baobab-scanner.vala"
			for (results_it = 0; results_it < results_collection_length1; results_it = results_it + 1) {
#line 1277 "baobab-scanner.c"
				BaobabScannerResults* results = NULL;
#line 360 "../src/baobab-scanner.vala"
				results = results_collection[results_it];
#line 1281 "baobab-scanner.c"
				{
					BaobabScannerResults* _tmp5_;
					BaobabScannerState state = 0;
					BaobabScannerResults* _tmp6_;
					BaobabScannerResults* _tmp9_;
					GtkTreeIter _tmp10_;
					BaobabScannerResults* _tmp11_;
					BaobabScannerResults* _tmp12_;
					BaobabScannerResults* _tmp13_;
					BaobabScannerResults* _tmp14_;
					BaobabScannerResults* _tmp18_;
					gint _tmp19_;
					BaobabScannerResults* _tmp21_;
					BaobabScannerResults* _tmp22_;
#line 361 "../src/baobab-scanner.vala"
					_tmp5_ = results;
#line 361 "../src/baobab-scanner.vala"
					baobab_scanner_ensure_iter_exists (self, _tmp5_);
#line 364 "../src/baobab-scanner.vala"
					_tmp6_ = results;
#line 364 "../src/baobab-scanner.vala"
					if (_tmp6_->child_error) {
#line 365 "../src/baobab-scanner.vala"
						state = BAOBAB_SCANNER_STATE_CHILD_ERROR;
#line 1306 "baobab-scanner.c"
					} else {
						BaobabScannerResults* _tmp7_;
						GError* _tmp8_;
#line 366 "../src/baobab-scanner.vala"
						_tmp7_ = results;
#line 366 "../src/baobab-scanner.vala"
						_tmp8_ = _tmp7_->error;
#line 366 "../src/baobab-scanner.vala"
						if (_tmp8_ != NULL) {
#line 367 "../src/baobab-scanner.vala"
							state = BAOBAB_SCANNER_STATE_ERROR;
#line 1318 "baobab-scanner.c"
						} else {
#line 369 "../src/baobab-scanner.vala"
							state = BAOBAB_SCANNER_STATE_DONE;
#line 1322 "baobab-scanner.c"
						}
					}
#line 372 "../src/baobab-scanner.vala"
					_tmp9_ = results;
#line 372 "../src/baobab-scanner.vala"
					_tmp10_ = _tmp9_->iter;
#line 372 "../src/baobab-scanner.vala"
					_tmp11_ = results;
#line 372 "../src/baobab-scanner.vala"
					_tmp12_ = results;
#line 372 "../src/baobab-scanner.vala"
					_tmp13_ = results;
#line 372 "../src/baobab-scanner.vala"
					gtk_tree_store_set ((GtkTreeStore*) self, &_tmp10_, BAOBAB_SCANNER_COLUMNS_PERCENT, _tmp11_->percent, BAOBAB_SCANNER_COLUMNS_SIZE, _tmp12_->size, BAOBAB_SCANNER_COLUMNS_TIME_MODIFIED, _tmp13_->time_modified, -1);
#line 378 "../src/baobab-scanner.vala"
					_tmp14_ = results;
#line 378 "../src/baobab-scanner.vala"
					if (_tmp14_->file_type == G_FILE_TYPE_DIRECTORY) {
#line 1341 "baobab-scanner.c"
						BaobabScannerResults* _tmp15_;
						GtkTreeIter _tmp16_;
						BaobabScannerResults* _tmp17_;
#line 379 "../src/baobab-scanner.vala"
						_tmp15_ = results;
#line 379 "../src/baobab-scanner.vala"
						_tmp16_ = _tmp15_->iter;
#line 379 "../src/baobab-scanner.vala"
						_tmp17_ = results;
#line 379 "../src/baobab-scanner.vala"
						gtk_tree_store_set ((GtkTreeStore*) self, &_tmp16_, BAOBAB_SCANNER_COLUMNS_ELEMENTS, _tmp17_->elements, BAOBAB_SCANNER_COLUMNS_STATE, state, -1);
#line 1353 "baobab-scanner.c"
					}
#line 384 "../src/baobab-scanner.vala"
					_tmp18_ = results;
#line 384 "../src/baobab-scanner.vala"
					_tmp19_ = self->priv->_max_depth;
#line 384 "../src/baobab-scanner.vala"
					if (_tmp18_->max_depth > _tmp19_) {
#line 1361 "baobab-scanner.c"
						BaobabScannerResults* _tmp20_;
#line 385 "../src/baobab-scanner.vala"
						_tmp20_ = results;
#line 385 "../src/baobab-scanner.vala"
						baobab_scanner_set_max_depth (self, _tmp20_->max_depth);
#line 1367 "baobab-scanner.c"
					}
#line 388 "../src/baobab-scanner.vala"
					_tmp21_ = results;
#line 388 "../src/baobab-scanner.vala"
					_tmp22_ = _tmp21_->parent;
#line 388 "../src/baobab-scanner.vala"
					if (_tmp22_ == NULL) {
#line 1375 "baobab-scanner.c"
						BaobabScannerResults* _tmp23_;
						GError* _tmp24_;
						GError* _tmp25_;
#line 389 "../src/baobab-scanner.vala"
						_tmp23_ = results;
#line 389 "../src/baobab-scanner.vala"
						_tmp24_ = _tmp23_->error;
#line 389 "../src/baobab-scanner.vala"
						_tmp25_ = _g_error_copy0 (_tmp24_);
#line 389 "../src/baobab-scanner.vala"
						_g_error_free0 (self->priv->scan_error);
#line 389 "../src/baobab-scanner.vala"
						self->priv->scan_error = _tmp25_;
#line 390 "../src/baobab-scanner.vala"
						self->priv->successful = TRUE;
#line 391 "../src/baobab-scanner.vala"
						g_signal_emit (self, baobab_scanner_signals[BAOBAB_SCANNER_COMPLETED_SIGNAL], 0);
#line 392 "../src/baobab-scanner.vala"
						result = FALSE;
#line 392 "../src/baobab-scanner.vala"
						_baobab_scanner_results_array_free0 (results_array);
#line 392 "../src/baobab-scanner.vala"
						return result;
#line 1399 "baobab-scanner.c"
					}
				}
			}
		}
#line 353 "../src/baobab-scanner.vala"
		_baobab_scanner_results_array_free0 (results_array);
#line 1406 "baobab-scanner.c"
	}
#line 397 "../src/baobab-scanner.vala"
	_tmp26_ = self->priv->self;
#line 397 "../src/baobab-scanner.vala"
	result = _tmp26_ != NULL;
#line 397 "../src/baobab-scanner.vala"
	return result;
#line 1414 "baobab-scanner.c"
}

static guint
_baobab_scanner_hard_link_hash_ghash_func (gconstpointer key)
{
	guint result;
	result = baobab_scanner_hard_link_hash (key);
#line 419 "../src/baobab-scanner.vala"
	return result;
#line 1424 "baobab-scanner.c"
}

static gboolean
_baobab_scanner_hard_link_equal_gequal_func (gconstpointer a,
                                             gconstpointer b)
{
	gboolean result;
	result = baobab_scanner_hard_link_equal (a, (BaobabScannerHardLink*) b);
#line 419 "../src/baobab-scanner.vala"
	return result;
#line 1435 "baobab-scanner.c"
}

static void
_baobab_scanner_hard_link_free0_ (gpointer var)
{
#line 419 "../src/baobab-scanner.vala"
	(var == NULL) ? NULL : (var = (baobab_scanner_hard_link_free (var), NULL));
#line 1443 "baobab-scanner.c"
}

static void
baobab_scanner_cancel_and_reset (BaobabScanner* self)
{
	GCancellable* _tmp0_;
	GThread* _tmp1_;
	BaobabScannerResultsArray* tmp = NULL;
	GAsyncQueue* _tmp3_;
	gpointer _tmp4_;
	GHashTable* _tmp8_;
	GCancellable* _tmp9_;
	BaobabApplication* _tmp10_;
	BaobabApplication* _tmp11_;
	GHashTable* _tmp12_;
#line 400 "../src/baobab-scanner.vala"
	g_return_if_fail (self != NULL);
#line 401 "../src/baobab-scanner.vala"
	_tmp0_ = self->priv->cancellable;
#line 401 "../src/baobab-scanner.vala"
	g_cancellable_cancel (_tmp0_);
#line 403 "../src/baobab-scanner.vala"
	_tmp1_ = self->priv->thread;
#line 403 "../src/baobab-scanner.vala"
	if (_tmp1_ != NULL) {
#line 1469 "baobab-scanner.c"
		GThread* _tmp2_;
#line 404 "../src/baobab-scanner.vala"
		_tmp2_ = self->priv->thread;
#line 404 "../src/baobab-scanner.vala"
		self->priv->thread = NULL;
#line 404 "../src/baobab-scanner.vala"
		g_thread_join (_tmp2_);
#line 405 "../src/baobab-scanner.vala"
		_g_thread_unref0 (self->priv->thread);
#line 405 "../src/baobab-scanner.vala"
		self->priv->thread = NULL;
#line 1481 "baobab-scanner.c"
	}
#line 408 "../src/baobab-scanner.vala"
	if (self->priv->process_result_idle != ((guint) 0)) {
#line 409 "../src/baobab-scanner.vala"
		g_source_remove (self->priv->process_result_idle);
#line 410 "../src/baobab-scanner.vala"
		self->priv->process_result_idle = (guint) 0;
#line 1489 "baobab-scanner.c"
	}
#line 414 "../src/baobab-scanner.vala"
	_tmp3_ = self->priv->results_queue;
#line 414 "../src/baobab-scanner.vala"
	_tmp4_ = g_async_queue_try_pop (_tmp3_);
#line 414 "../src/baobab-scanner.vala"
	tmp = (BaobabScannerResultsArray*) _tmp4_;
#line 415 "../src/baobab-scanner.vala"
	while (TRUE) {
#line 1499 "baobab-scanner.c"
		BaobabScannerResultsArray* _tmp5_;
		GAsyncQueue* _tmp6_;
		gpointer _tmp7_;
#line 415 "../src/baobab-scanner.vala"
		_tmp5_ = tmp;
#line 415 "../src/baobab-scanner.vala"
		if (!(_tmp5_ != NULL)) {
#line 415 "../src/baobab-scanner.vala"
			break;
#line 1509 "baobab-scanner.c"
		}
#line 416 "../src/baobab-scanner.vala"
		_tmp6_ = self->priv->results_queue;
#line 416 "../src/baobab-scanner.vala"
		_tmp7_ = g_async_queue_try_pop (_tmp6_);
#line 416 "../src/baobab-scanner.vala"
		_baobab_scanner_results_array_free0 (tmp);
#line 416 "../src/baobab-scanner.vala"
		tmp = (BaobabScannerResultsArray*) _tmp7_;
#line 1519 "baobab-scanner.c"
	}
#line 419 "../src/baobab-scanner.vala"
	_tmp8_ = g_hash_table_new_full (_baobab_scanner_hard_link_hash_ghash_func, _baobab_scanner_hard_link_equal_gequal_func, NULL, _baobab_scanner_hard_link_free0_);
#line 419 "../src/baobab-scanner.vala"
	_g_hash_table_unref0 (self->priv->hardlinks);
#line 419 "../src/baobab-scanner.vala"
	self->priv->hardlinks = _tmp8_;
#line 421 "../src/baobab-scanner.vala"
	gtk_tree_store_clear (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_tree_store_get_type (), GtkTreeStore));
#line 422 "../src/baobab-scanner.vala"
	gtk_tree_sortable_set_sort_column_id ((GtkTreeSortable*) self, GTK_TREE_SORTABLE_UNSORTED_SORT_COLUMN_ID, GTK_SORT_DESCENDING);
#line 424 "../src/baobab-scanner.vala"
	_tmp9_ = self->priv->cancellable;
#line 424 "../src/baobab-scanner.vala"
	g_cancellable_reset (_tmp9_);
#line 425 "../src/baobab-scanner.vala"
	_g_error_free0 (self->priv->scan_error);
#line 425 "../src/baobab-scanner.vala"
	self->priv->scan_error = NULL;
#line 426 "../src/baobab-scanner.vala"
	baobab_scanner_set_total_size (self, (guint64) 0);
#line 427 "../src/baobab-scanner.vala"
	baobab_scanner_set_total_elements (self, 0);
#line 429 "../src/baobab-scanner.vala"
	_tmp10_ = baobab_application_get_default ();
#line 429 "../src/baobab-scanner.vala"
	_tmp11_ = _tmp10_;
#line 429 "../src/baobab-scanner.vala"
	_tmp12_ = baobab_application_get_excluded_locations (_tmp11_);
#line 429 "../src/baobab-scanner.vala"
	_g_hash_table_unref0 (self->priv->excluded_locations);
#line 429 "../src/baobab-scanner.vala"
	self->priv->excluded_locations = _tmp12_;
#line 429 "../src/baobab-scanner.vala"
	_g_object_unref0 (_tmp11_);
#line 400 "../src/baobab-scanner.vala"
	_baobab_scanner_results_array_free0 (tmp);
#line 1557 "baobab-scanner.c"
}

static gpointer
_baobab_scanner_scan_in_thread_gthread_func (gpointer self)
{
	gpointer result;
	result = baobab_scanner_scan_in_thread ((BaobabScanner*) self);
#line 443 "../src/baobab-scanner.vala"
	g_object_unref (self);
#line 443 "../src/baobab-scanner.vala"
	return result;
#line 1569 "baobab-scanner.c"
}

static gboolean
___lambda4_ (BaobabScanner* self)
{
	gboolean res = FALSE;
	gboolean result;
#line 446 "../src/baobab-scanner.vala"
	res = baobab_scanner_process_results (self);
#line 447 "../src/baobab-scanner.vala"
	if (!res) {
#line 448 "../src/baobab-scanner.vala"
		self->priv->process_result_idle = (guint) 0;
#line 1583 "baobab-scanner.c"
	}
#line 450 "../src/baobab-scanner.vala"
	result = res;
#line 450 "../src/baobab-scanner.vala"
	return result;
#line 1589 "baobab-scanner.c"
}

static gboolean
____lambda4__gsource_func (gpointer self)
{
	gboolean result;
	result = ___lambda4_ ((BaobabScanner*) self);
#line 445 "../src/baobab-scanner.vala"
	return result;
#line 1599 "baobab-scanner.c"
}

void
baobab_scanner_scan (BaobabScanner* self,
                     gboolean force)
{
#line 432 "../src/baobab-scanner.vala"
	g_return_if_fail (self != NULL);
#line 433 "../src/baobab-scanner.vala"
	if (force) {
#line 434 "../src/baobab-scanner.vala"
		self->priv->successful = FALSE;
#line 1612 "baobab-scanner.c"
	}
#line 437 "../src/baobab-scanner.vala"
	if (!self->priv->successful) {
#line 1616 "baobab-scanner.c"
		BaobabScanner* _tmp0_;
		GThread* _tmp1_;
#line 438 "../src/baobab-scanner.vala"
		baobab_scanner_cancel_and_reset (self);
#line 441 "../src/baobab-scanner.vala"
		_tmp0_ = _g_object_ref0 (self);
#line 441 "../src/baobab-scanner.vala"
		_g_object_unref0 (self->priv->self);
#line 441 "../src/baobab-scanner.vala"
		self->priv->self = _tmp0_;
#line 443 "../src/baobab-scanner.vala"
		_tmp1_ = g_thread_new ("scanner", _baobab_scanner_scan_in_thread_gthread_func, g_object_ref (self));
#line 443 "../src/baobab-scanner.vala"
		_g_thread_unref0 (self->priv->thread);
#line 443 "../src/baobab-scanner.vala"
		self->priv->thread = _tmp1_;
#line 445 "../src/baobab-scanner.vala"
		self->priv->process_result_idle = g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) 100, ____lambda4__gsource_func, g_object_ref (self), g_object_unref);
#line 1635 "baobab-scanner.c"
	} else {
#line 453 "../src/baobab-scanner.vala"
		g_signal_emit (self, baobab_scanner_signals[BAOBAB_SCANNER_COMPLETED_SIGNAL], 0);
#line 1639 "baobab-scanner.c"
	}
}

void
baobab_scanner_cancel (BaobabScanner* self)
{
#line 457 "../src/baobab-scanner.vala"
	g_return_if_fail (self != NULL);
#line 458 "../src/baobab-scanner.vala"
	if (!self->priv->successful) {
#line 1650 "baobab-scanner.c"
		GError* _tmp0_;
#line 459 "../src/baobab-scanner.vala"
		baobab_scanner_cancel_and_reset (self);
#line 460 "../src/baobab-scanner.vala"
		_tmp0_ = g_error_new_literal (G_IO_ERROR, G_IO_ERROR_CANCELLED, "Scan was cancelled");
#line 460 "../src/baobab-scanner.vala"
		_g_error_free0 (self->priv->scan_error);
#line 460 "../src/baobab-scanner.vala"
		self->priv->scan_error = _tmp0_;
#line 1660 "baobab-scanner.c"
	}
#line 462 "../src/baobab-scanner.vala"
	g_signal_emit (self, baobab_scanner_signals[BAOBAB_SCANNER_COMPLETED_SIGNAL], 0);
#line 1664 "baobab-scanner.c"
}

void
baobab_scanner_finish (BaobabScanner* self,
                       GError** error)
{
	GError* _tmp0_;
	GError* _inner_error0_ = NULL;
#line 465 "../src/baobab-scanner.vala"
	g_return_if_fail (self != NULL);
#line 466 "../src/baobab-scanner.vala"
	gtk_tree_sortable_set_sort_column_id ((GtkTreeSortable*) self, (gint) BAOBAB_SCANNER_COLUMNS_SIZE, GTK_SORT_DESCENDING);
#line 468 "../src/baobab-scanner.vala"
	_tmp0_ = self->priv->scan_error;
#line 468 "../src/baobab-scanner.vala"
	if (_tmp0_ != NULL) {
#line 1681 "baobab-scanner.c"
		GError* _tmp1_;
		GError* _tmp2_;
#line 469 "../src/baobab-scanner.vala"
		_tmp1_ = self->priv->scan_error;
#line 469 "../src/baobab-scanner.vala"
		_tmp2_ = _g_error_copy0 (_tmp1_);
#line 469 "../src/baobab-scanner.vala"
		_inner_error0_ = _tmp2_;
#line 469 "../src/baobab-scanner.vala"
		g_propagate_error (error, _inner_error0_);
#line 469 "../src/baobab-scanner.vala"
		return;
#line 1694 "baobab-scanner.c"
	}
}

static void
_baobab_scanner_results_array_free0_ (gpointer var)
{
#line 488 "../src/baobab-scanner.vala"
	(var == NULL) ? NULL : (var = (baobab_scanner_results_array_free (var), NULL));
#line 1703 "baobab-scanner.c"
}

BaobabScanner*
baobab_scanner_construct (GType object_type,
                          GFile* directory,
                          BaobabScanFlags flags)
{
	BaobabScanner * self = NULL;
	GCancellable* _tmp0_;
	GType* _tmp1_;
	GType* _tmp2_;
	gint _tmp2__length1;
	GAsyncQueue* _tmp3_;
#line 473 "../src/baobab-scanner.vala"
	g_return_val_if_fail (directory != NULL, NULL);
#line 473 "../src/baobab-scanner.vala"
	self = (BaobabScanner*) g_object_new (object_type, NULL);
#line 474 "../src/baobab-scanner.vala"
	baobab_scanner_set_directory (self, directory);
#line 475 "../src/baobab-scanner.vala"
	baobab_scanner_set_scan_flags (self, flags);
#line 476 "../src/baobab-scanner.vala"
	_tmp0_ = g_cancellable_new ();
#line 476 "../src/baobab-scanner.vala"
	_g_object_unref0 (self->priv->cancellable);
#line 476 "../src/baobab-scanner.vala"
	self->priv->cancellable = _tmp0_;
#line 477 "../src/baobab-scanner.vala"
	_g_error_free0 (self->priv->scan_error);
#line 477 "../src/baobab-scanner.vala"
	self->priv->scan_error = NULL;
#line 478 "../src/baobab-scanner.vala"
	_tmp1_ = g_new0 (GType, 7);
#line 478 "../src/baobab-scanner.vala"
	_tmp1_[0] = G_TYPE_STRING;
#line 478 "../src/baobab-scanner.vala"
	_tmp1_[1] = G_TYPE_DOUBLE;
#line 478 "../src/baobab-scanner.vala"
	_tmp1_[2] = G_TYPE_UINT64;
#line 478 "../src/baobab-scanner.vala"
	_tmp1_[3] = G_TYPE_UINT64;
#line 478 "../src/baobab-scanner.vala"
	_tmp1_[4] = G_TYPE_STRING;
#line 478 "../src/baobab-scanner.vala"
	_tmp1_[5] = G_TYPE_INT;
#line 478 "../src/baobab-scanner.vala"
	_tmp1_[6] = BAOBAB_SCANNER_TYPE_STATE;
#line 478 "../src/baobab-scanner.vala"
	_tmp2_ = _tmp1_;
#line 478 "../src/baobab-scanner.vala"
	_tmp2__length1 = 7;
#line 478 "../src/baobab-scanner.vala"
	gtk_tree_store_set_column_types ((GtkTreeStore*) self, (gint) 7, _tmp2_);
#line 478 "../src/baobab-scanner.vala"
	_tmp2_ = (g_free (_tmp2_), NULL);
#line 488 "../src/baobab-scanner.vala"
	_tmp3_ = g_async_queue_new_full (_baobab_scanner_results_array_free0_);
#line 488 "../src/baobab-scanner.vala"
	_g_async_queue_unref0 (self->priv->results_queue);
#line 488 "../src/baobab-scanner.vala"
	self->priv->results_queue = _tmp3_;
#line 473 "../src/baobab-scanner.vala"
	return self;
#line 1767 "baobab-scanner.c"
}

BaobabScanner*
baobab_scanner_new (GFile* directory,
                    BaobabScanFlags flags)
{
#line 473 "../src/baobab-scanner.vala"
	return baobab_scanner_construct (BAOBAB_TYPE_SCANNER, directory, flags);
#line 1776 "baobab-scanner.c"
}

GFile*
baobab_scanner_get_directory (BaobabScanner* self)
{
	GFile* result;
	GFile* _tmp0_;
#line 50 "../src/baobab-scanner.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 50 "../src/baobab-scanner.vala"
	_tmp0_ = self->priv->_directory;
#line 50 "../src/baobab-scanner.vala"
	result = _tmp0_;
#line 50 "../src/baobab-scanner.vala"
	return result;
#line 1792 "baobab-scanner.c"
}

static void
baobab_scanner_set_directory (BaobabScanner* self,
                              GFile* value)
{
	GFile* old_value;
#line 50 "../src/baobab-scanner.vala"
	g_return_if_fail (self != NULL);
#line 50 "../src/baobab-scanner.vala"
	old_value = baobab_scanner_get_directory (self);
#line 50 "../src/baobab-scanner.vala"
	if (old_value != value) {
#line 1806 "baobab-scanner.c"
		GFile* _tmp0_;
#line 50 "../src/baobab-scanner.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 50 "../src/baobab-scanner.vala"
		_g_object_unref0 (self->priv->_directory);
#line 50 "../src/baobab-scanner.vala"
		self->priv->_directory = _tmp0_;
#line 50 "../src/baobab-scanner.vala"
		g_object_notify_by_pspec ((GObject *) self, baobab_scanner_properties[BAOBAB_SCANNER_DIRECTORY_PROPERTY]);
#line 1816 "baobab-scanner.c"
	}
}

BaobabScanFlags
baobab_scanner_get_scan_flags (BaobabScanner* self)
{
	BaobabScanFlags result;
#line 52 "../src/baobab-scanner.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 52 "../src/baobab-scanner.vala"
	result = self->priv->_scan_flags;
#line 52 "../src/baobab-scanner.vala"
	return result;
#line 1830 "baobab-scanner.c"
}

static void
baobab_scanner_set_scan_flags (BaobabScanner* self,
                               BaobabScanFlags value)
{
	BaobabScanFlags old_value;
#line 52 "../src/baobab-scanner.vala"
	g_return_if_fail (self != NULL);
#line 52 "../src/baobab-scanner.vala"
	old_value = baobab_scanner_get_scan_flags (self);
#line 52 "../src/baobab-scanner.vala"
	if (old_value != value) {
#line 52 "../src/baobab-scanner.vala"
		self->priv->_scan_flags = value;
#line 52 "../src/baobab-scanner.vala"
		g_object_notify_by_pspec ((GObject *) self, baobab_scanner_properties[BAOBAB_SCANNER_SCAN_FLAGS_PROPERTY]);
#line 1848 "baobab-scanner.c"
	}
}

gboolean
baobab_scanner_get_show_allocated_size (BaobabScanner* self)
{
	gboolean result;
#line 54 "../src/baobab-scanner.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 54 "../src/baobab-scanner.vala"
	result = self->priv->_show_allocated_size;
#line 54 "../src/baobab-scanner.vala"
	return result;
#line 1862 "baobab-scanner.c"
}

static void
baobab_scanner_set_show_allocated_size (BaobabScanner* self,
                                        gboolean value)
{
	gboolean old_value;
#line 54 "../src/baobab-scanner.vala"
	g_return_if_fail (self != NULL);
#line 54 "../src/baobab-scanner.vala"
	old_value = baobab_scanner_get_show_allocated_size (self);
#line 54 "../src/baobab-scanner.vala"
	if (old_value != value) {
#line 54 "../src/baobab-scanner.vala"
		self->priv->_show_allocated_size = value;
#line 54 "../src/baobab-scanner.vala"
		g_object_notify_by_pspec ((GObject *) self, baobab_scanner_properties[BAOBAB_SCANNER_SHOW_ALLOCATED_SIZE_PROPERTY]);
#line 1880 "baobab-scanner.c"
	}
}

guint64
baobab_scanner_get_total_size (BaobabScanner* self)
{
	guint64 result;
#line 57 "../src/baobab-scanner.vala"
	g_return_val_if_fail (self != NULL, 0ULL);
#line 57 "../src/baobab-scanner.vala"
	result = self->priv->_total_size;
#line 57 "../src/baobab-scanner.vala"
	return result;
#line 1894 "baobab-scanner.c"
}

static void
baobab_scanner_set_total_size (BaobabScanner* self,
                               guint64 value)
{
	guint64 old_value;
#line 57 "../src/baobab-scanner.vala"
	g_return_if_fail (self != NULL);
#line 57 "../src/baobab-scanner.vala"
	old_value = baobab_scanner_get_total_size (self);
#line 57 "../src/baobab-scanner.vala"
	if (old_value != value) {
#line 57 "../src/baobab-scanner.vala"
		self->priv->_total_size = value;
#line 57 "../src/baobab-scanner.vala"
		g_object_notify_by_pspec ((GObject *) self, baobab_scanner_properties[BAOBAB_SCANNER_TOTAL_SIZE_PROPERTY]);
#line 1912 "baobab-scanner.c"
	}
}

gint
baobab_scanner_get_total_elements (BaobabScanner* self)
{
	gint result;
#line 58 "../src/baobab-scanner.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 58 "../src/baobab-scanner.vala"
	result = self->priv->_total_elements;
#line 58 "../src/baobab-scanner.vala"
	return result;
#line 1926 "baobab-scanner.c"
}

static void
baobab_scanner_set_total_elements (BaobabScanner* self,
                                   gint value)
{
	gint old_value;
#line 58 "../src/baobab-scanner.vala"
	g_return_if_fail (self != NULL);
#line 58 "../src/baobab-scanner.vala"
	old_value = baobab_scanner_get_total_elements (self);
#line 58 "../src/baobab-scanner.vala"
	if (old_value != value) {
#line 58 "../src/baobab-scanner.vala"
		self->priv->_total_elements = value;
#line 58 "../src/baobab-scanner.vala"
		g_object_notify_by_pspec ((GObject *) self, baobab_scanner_properties[BAOBAB_SCANNER_TOTAL_ELEMENTS_PROPERTY]);
#line 1944 "baobab-scanner.c"
	}
}

gint
baobab_scanner_get_max_depth (BaobabScanner* self)
{
	gint result;
#line 60 "../src/baobab-scanner.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 60 "../src/baobab-scanner.vala"
	result = self->priv->_max_depth;
#line 60 "../src/baobab-scanner.vala"
	return result;
#line 1958 "baobab-scanner.c"
}

void
baobab_scanner_set_max_depth (BaobabScanner* self,
                              gint value)
{
	gint old_value;
#line 60 "../src/baobab-scanner.vala"
	g_return_if_fail (self != NULL);
#line 60 "../src/baobab-scanner.vala"
	old_value = baobab_scanner_get_max_depth (self);
#line 60 "../src/baobab-scanner.vala"
	if (old_value != value) {
#line 60 "../src/baobab-scanner.vala"
		self->priv->_max_depth = value;
#line 60 "../src/baobab-scanner.vala"
		g_object_notify_by_pspec ((GObject *) self, baobab_scanner_properties[BAOBAB_SCANNER_MAX_DEPTH_PROPERTY]);
#line 1976 "baobab-scanner.c"
	}
}

static BaobabScannerHardLink*
baobab_scanner_hard_link_new (GFileInfo* info)
{
	BaobabScannerHardLink* self;
#line 100 "../src/baobab-scanner.vala"
	g_return_val_if_fail (info != NULL, NULL);
#line 100 "../src/baobab-scanner.vala"
	self = g_slice_new0 (BaobabScannerHardLink);
#line 100 "../src/baobab-scanner.vala"
	baobab_scanner_hard_link_instance_init (self);
#line 101 "../src/baobab-scanner.vala"
	self->inode = g_file_info_get_attribute_uint64 (info, G_FILE_ATTRIBUTE_UNIX_INODE);
#line 102 "../src/baobab-scanner.vala"
	self->device = g_file_info_get_attribute_uint32 (info, G_FILE_ATTRIBUTE_UNIX_DEVICE);
#line 100 "../src/baobab-scanner.vala"
	return self;
#line 1996 "baobab-scanner.c"
}

static guint
baobab_scanner_hard_link_hash (BaobabScannerHardLink* self)
{
	GHashFunc _tmp0_;
	GHashFunc _tmp1_;
	guint result;
#line 105 "../src/baobab-scanner.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 106 "../src/baobab-scanner.vala"
	_tmp0_ = g_direct_hash;
#line 106 "../src/baobab-scanner.vala"
	_tmp1_ = g_direct_hash;
#line 106 "../src/baobab-scanner.vala"
	result = _tmp0_ ((void*) self->inode) ^ _tmp1_ ((void*) self->device);
#line 106 "../src/baobab-scanner.vala"
	return result;
#line 2015 "baobab-scanner.c"
}

static gboolean
baobab_scanner_hard_link_equal (BaobabScannerHardLink* self,
                                BaobabScannerHardLink* other)
{
	gboolean _tmp0_ = FALSE;
	gboolean result;
#line 109 "../src/baobab-scanner.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 109 "../src/baobab-scanner.vala"
	g_return_val_if_fail (other != NULL, FALSE);
#line 110 "../src/baobab-scanner.vala"
	if (self->inode == other->inode) {
#line 110 "../src/baobab-scanner.vala"
		_tmp0_ = self->device == other->device;
#line 2032 "baobab-scanner.c"
	} else {
#line 110 "../src/baobab-scanner.vala"
		_tmp0_ = FALSE;
#line 2036 "baobab-scanner.c"
	}
#line 110 "../src/baobab-scanner.vala"
	result = _tmp0_;
#line 110 "../src/baobab-scanner.vala"
	return result;
#line 2042 "baobab-scanner.c"
}

static void
baobab_scanner_hard_link_instance_init (BaobabScannerHardLink * self)
{
}

static void
baobab_scanner_hard_link_free (BaobabScannerHardLink * self)
{
#line 96 "../src/baobab-scanner.vala"
	g_slice_free (BaobabScannerHardLink, self);
#line 2055 "baobab-scanner.c"
}

static BaobabScannerResultsArray*
baobab_scanner_results_array_new (void)
{
	BaobabScannerResultsArray* self;
#line 165 "../src/baobab-scanner.vala"
	self = g_slice_new0 (BaobabScannerResultsArray);
#line 165 "../src/baobab-scanner.vala"
	baobab_scanner_results_array_instance_init (self);
#line 165 "../src/baobab-scanner.vala"
	return self;
#line 2068 "baobab-scanner.c"
}

static void
baobab_scanner_results_array_instance_init (BaobabScannerResultsArray * self)
{
}

static void
baobab_scanner_results_array_free (BaobabScannerResultsArray * self)
{
#line 166 "../src/baobab-scanner.vala"
	self->results = (_vala_array_free (self->results, self->results_length1, (GDestroyNotify) baobab_scanner_results_free), NULL);
#line 165 "../src/baobab-scanner.vala"
	g_slice_free (BaobabScannerResultsArray, self);
#line 2083 "baobab-scanner.c"
}

static BaobabScannerResults*
baobab_scanner_results_new (GFileInfo* info,
                            BaobabScannerResults* parent_results)
{
	BaobabScannerResults* self;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* info_display_name = NULL;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	gboolean _tmp4_ = FALSE;
	const gchar* _tmp5_;
#line 192 "../src/baobab-scanner.vala"
	g_return_val_if_fail (info != NULL, NULL);
#line 192 "../src/baobab-scanner.vala"
	self = g_slice_new0 (BaobabScannerResults);
#line 192 "../src/baobab-scanner.vala"
	baobab_scanner_results_instance_init (self);
#line 193 "../src/baobab-scanner.vala"
	self->parent = parent_results;
#line 194 "../src/baobab-scanner.vala"
	_tmp0_ = g_file_info_get_name (info);
#line 194 "../src/baobab-scanner.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 194 "../src/baobab-scanner.vala"
	_g_free0 (self->name);
#line 194 "../src/baobab-scanner.vala"
	self->name = _tmp1_;
#line 195 "../src/baobab-scanner.vala"
	_tmp2_ = g_file_info_get_display_name (info);
#line 195 "../src/baobab-scanner.vala"
	_tmp3_ = g_strdup (_tmp2_);
#line 195 "../src/baobab-scanner.vala"
	info_display_name = _tmp3_;
#line 196 "../src/baobab-scanner.vala"
	_tmp5_ = self->name;
#line 196 "../src/baobab-scanner.vala"
	if (_tmp5_ == NULL) {
#line 196 "../src/baobab-scanner.vala"
		_tmp4_ = TRUE;
#line 2126 "baobab-scanner.c"
	} else {
		const gchar* _tmp6_;
		const gchar* _tmp7_;
		gchar* _tmp8_;
		gchar* _tmp9_;
#line 196 "../src/baobab-scanner.vala"
		_tmp6_ = info_display_name;
#line 196 "../src/baobab-scanner.vala"
		_tmp7_ = self->name;
#line 196 "../src/baobab-scanner.vala"
		_tmp8_ = g_filename_display_name (_tmp7_);
#line 196 "../src/baobab-scanner.vala"
		_tmp9_ = _tmp8_;
#line 196 "../src/baobab-scanner.vala"
		_tmp4_ = g_strcmp0 (_tmp6_, _tmp9_) != 0;
#line 196 "../src/baobab-scanner.vala"
		_g_free0 (_tmp9_);
#line 2144 "baobab-scanner.c"
	}
#line 196 "../src/baobab-scanner.vala"
	if (_tmp4_) {
#line 2148 "baobab-scanner.c"
		const gchar* _tmp10_;
		gchar* _tmp11_;
#line 197 "../src/baobab-scanner.vala"
		_tmp10_ = info_display_name;
#line 197 "../src/baobab-scanner.vala"
		_tmp11_ = g_strdup (_tmp10_);
#line 197 "../src/baobab-scanner.vala"
		_g_free0 (self->display_name);
#line 197 "../src/baobab-scanner.vala"
		self->display_name = _tmp11_;
#line 2159 "baobab-scanner.c"
	}
#line 199 "../src/baobab-scanner.vala"
	self->file_type = g_file_info_get_file_type (info);
#line 200 "../src/baobab-scanner.vala"
	self->size = g_file_info_get_attribute_uint64 (info, G_FILE_ATTRIBUTE_STANDARD_ALLOCATED_SIZE);
#line 201 "../src/baobab-scanner.vala"
	if (self->size == ((guint64) 0)) {
#line 202 "../src/baobab-scanner.vala"
		self->size = (guint64) g_file_info_get_size (info);
#line 2169 "baobab-scanner.c"
	}
#line 204 "../src/baobab-scanner.vala"
	self->time_modified = g_file_info_get_attribute_uint64 (info, G_FILE_ATTRIBUTE_TIME_MODIFIED);
#line 205 "../src/baobab-scanner.vala"
	self->elements = 1;
#line 206 "../src/baobab-scanner.vala"
	_g_error_free0 (self->error);
#line 206 "../src/baobab-scanner.vala"
	self->error = NULL;
#line 207 "../src/baobab-scanner.vala"
	self->child_error = FALSE;
#line 192 "../src/baobab-scanner.vala"
	_g_free0 (info_display_name);
#line 192 "../src/baobab-scanner.vala"
	return self;
#line 2185 "baobab-scanner.c"
}

static void
baobab_scanner_results_update_with_child (BaobabScannerResults* self,
                                          BaobabScannerResults* child)
{
	gboolean _tmp0_ = FALSE;
#line 210 "../src/baobab-scanner.vala"
	g_return_if_fail (self != NULL);
#line 210 "../src/baobab-scanner.vala"
	g_return_if_fail (child != NULL);
#line 211 "../src/baobab-scanner.vala"
	self->size = self->size + child->size;
#line 212 "../src/baobab-scanner.vala"
	self->elements = self->elements + child->elements;
#line 213 "../src/baobab-scanner.vala"
	self->max_depth = MAX (self->max_depth, child->max_depth + 1);
#line 214 "../src/baobab-scanner.vala"
	if (child->child_error) {
#line 214 "../src/baobab-scanner.vala"
		_tmp0_ = TRUE;
#line 2207 "baobab-scanner.c"
	} else {
		GError* _tmp1_;
#line 214 "../src/baobab-scanner.vala"
		_tmp1_ = child->error;
#line 214 "../src/baobab-scanner.vala"
		_tmp0_ = _tmp1_ != NULL;
#line 2214 "baobab-scanner.c"
	}
#line 214 "../src/baobab-scanner.vala"
	self->child_error = self->child_error | _tmp0_;
#line 215 "../src/baobab-scanner.vala"
	self->time_modified = MAX (self->time_modified, child->time_modified);
#line 2220 "baobab-scanner.c"
}

static void
baobab_scanner_results_instance_init (BaobabScannerResults * self)
{
}

static void
baobab_scanner_results_free (BaobabScannerResults * self)
{
#line 174 "../src/baobab-scanner.vala"
	_g_free0 (self->name);
#line 175 "../src/baobab-scanner.vala"
	_g_free0 (self->display_name);
#line 185 "../src/baobab-scanner.vala"
	_g_error_free0 (self->error);
#line 170 "../src/baobab-scanner.vala"
	g_slice_free (BaobabScannerResults, self);
#line 2239 "baobab-scanner.c"
}

static void
baobab_scanner_class_init (BaobabScannerClass * klass,
                           gpointer klass_data)
{
#line 31 "../src/baobab-scanner.vala"
	baobab_scanner_parent_class = g_type_class_peek_parent (klass);
#line 31 "../src/baobab-scanner.vala"
	g_type_class_adjust_private_offset (klass, &BaobabScanner_private_offset);
#line 31 "../src/baobab-scanner.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_baobab_scanner_get_property;
#line 31 "../src/baobab-scanner.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_baobab_scanner_set_property;
#line 31 "../src/baobab-scanner.vala"
	G_OBJECT_CLASS (klass)->finalize = baobab_scanner_finalize;
#line 31 "../src/baobab-scanner.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), BAOBAB_SCANNER_DIRECTORY_PROPERTY, baobab_scanner_properties[BAOBAB_SCANNER_DIRECTORY_PROPERTY] = g_param_spec_object ("directory", "directory", "directory", g_file_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 31 "../src/baobab-scanner.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), BAOBAB_SCANNER_SCAN_FLAGS_PROPERTY, baobab_scanner_properties[BAOBAB_SCANNER_SCAN_FLAGS_PROPERTY] = g_param_spec_flags ("scan-flags", "scan-flags", "scan-flags", BAOBAB_TYPE_SCAN_FLAGS, 0U, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 31 "../src/baobab-scanner.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), BAOBAB_SCANNER_SHOW_ALLOCATED_SIZE_PROPERTY, baobab_scanner_properties[BAOBAB_SCANNER_SHOW_ALLOCATED_SIZE_PROPERTY] = g_param_spec_boolean ("show-allocated-size", "show-allocated-size", "show-allocated-size", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 31 "../src/baobab-scanner.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), BAOBAB_SCANNER_TOTAL_SIZE_PROPERTY, baobab_scanner_properties[BAOBAB_SCANNER_TOTAL_SIZE_PROPERTY] = g_param_spec_uint64 ("total-size", "total-size", "total-size", 0, G_MAXUINT64, 0U, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 31 "../src/baobab-scanner.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), BAOBAB_SCANNER_TOTAL_ELEMENTS_PROPERTY, baobab_scanner_properties[BAOBAB_SCANNER_TOTAL_ELEMENTS_PROPERTY] = g_param_spec_int ("total-elements", "total-elements", "total-elements", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 31 "../src/baobab-scanner.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), BAOBAB_SCANNER_MAX_DEPTH_PROPERTY, baobab_scanner_properties[BAOBAB_SCANNER_MAX_DEPTH_PROPERTY] = g_param_spec_int ("max-depth", "max-depth", "max-depth", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 31 "../src/baobab-scanner.vala"
	baobab_scanner_signals[BAOBAB_SCANNER_COMPLETED_SIGNAL] = g_signal_new ("completed", BAOBAB_TYPE_SCANNER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 2270 "baobab-scanner.c"
}

static void
baobab_scanner_instance_init (BaobabScanner * self,
                              gpointer klass)
{
#line 31 "../src/baobab-scanner.vala"
	self->priv = baobab_scanner_get_instance_private (self);
#line 114 "../src/baobab-scanner.vala"
	self->priv->thread = NULL;
#line 115 "../src/baobab-scanner.vala"
	self->priv->process_result_idle = (guint) 0;
#line 119 "../src/baobab-scanner.vala"
	self->priv->unix_device = (guint32) 0;
#line 121 "../src/baobab-scanner.vala"
	self->priv->successful = FALSE;
#line 2287 "baobab-scanner.c"
}

static void
baobab_scanner_finalize (GObject * obj)
{
	BaobabScanner * self;
#line 31 "../src/baobab-scanner.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, BAOBAB_TYPE_SCANNER, BaobabScanner);
#line 50 "../src/baobab-scanner.vala"
	_g_object_unref0 (self->priv->_directory);
#line 114 "../src/baobab-scanner.vala"
	_g_thread_unref0 (self->priv->thread);
#line 117 "../src/baobab-scanner.vala"
	_g_hash_table_unref0 (self->priv->hardlinks);
#line 118 "../src/baobab-scanner.vala"
	_g_hash_table_unref0 (self->priv->excluded_locations);
#line 159 "../src/baobab-scanner.vala"
	_g_async_queue_unref0 (self->priv->results_queue);
#line 160 "../src/baobab-scanner.vala"
	_g_object_unref0 (self->priv->self);
#line 161 "../src/baobab-scanner.vala"
	_g_object_unref0 (self->priv->cancellable);
#line 162 "../src/baobab-scanner.vala"
	_g_error_free0 (self->priv->scan_error);
#line 31 "../src/baobab-scanner.vala"
	G_OBJECT_CLASS (baobab_scanner_parent_class)->finalize (obj);
#line 2314 "baobab-scanner.c"
}

static GType
baobab_scanner_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (BaobabScannerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) baobab_scanner_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (BaobabScanner), 0, (GInstanceInitFunc) baobab_scanner_instance_init, NULL };
	GType baobab_scanner_type_id;
	baobab_scanner_type_id = g_type_register_static (gtk_tree_store_get_type (), "BaobabScanner", &g_define_type_info, 0);
	BaobabScanner_private_offset = g_type_add_instance_private (baobab_scanner_type_id, sizeof (BaobabScannerPrivate));
	return baobab_scanner_type_id;
}

GType
baobab_scanner_get_type (void)
{
	static volatile gsize baobab_scanner_type_id__once = 0;
	if (g_once_init_enter (&baobab_scanner_type_id__once)) {
		GType baobab_scanner_type_id;
		baobab_scanner_type_id = baobab_scanner_get_type_once ();
		g_once_init_leave (&baobab_scanner_type_id__once, baobab_scanner_type_id);
	}
	return baobab_scanner_type_id__once;
}

static void
_vala_baobab_scanner_get_property (GObject * object,
                                   guint property_id,
                                   GValue * value,
                                   GParamSpec * pspec)
{
	BaobabScanner * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, BAOBAB_TYPE_SCANNER, BaobabScanner);
#line 31 "../src/baobab-scanner.vala"
	switch (property_id) {
#line 31 "../src/baobab-scanner.vala"
		case BAOBAB_SCANNER_DIRECTORY_PROPERTY:
#line 31 "../src/baobab-scanner.vala"
		g_value_set_object (value, baobab_scanner_get_directory (self));
#line 31 "../src/baobab-scanner.vala"
		break;
#line 31 "../src/baobab-scanner.vala"
		case BAOBAB_SCANNER_SCAN_FLAGS_PROPERTY:
#line 31 "../src/baobab-scanner.vala"
		g_value_set_flags (value, baobab_scanner_get_scan_flags (self));
#line 31 "../src/baobab-scanner.vala"
		break;
#line 31 "../src/baobab-scanner.vala"
		case BAOBAB_SCANNER_SHOW_ALLOCATED_SIZE_PROPERTY:
#line 31 "../src/baobab-scanner.vala"
		g_value_set_boolean (value, baobab_scanner_get_show_allocated_size (self));
#line 31 "../src/baobab-scanner.vala"
		break;
#line 31 "../src/baobab-scanner.vala"
		case BAOBAB_SCANNER_TOTAL_SIZE_PROPERTY:
#line 31 "../src/baobab-scanner.vala"
		g_value_set_uint64 (value, baobab_scanner_get_total_size (self));
#line 31 "../src/baobab-scanner.vala"
		break;
#line 31 "../src/baobab-scanner.vala"
		case BAOBAB_SCANNER_TOTAL_ELEMENTS_PROPERTY:
#line 31 "../src/baobab-scanner.vala"
		g_value_set_int (value, baobab_scanner_get_total_elements (self));
#line 31 "../src/baobab-scanner.vala"
		break;
#line 31 "../src/baobab-scanner.vala"
		case BAOBAB_SCANNER_MAX_DEPTH_PROPERTY:
#line 31 "../src/baobab-scanner.vala"
		g_value_set_int (value, baobab_scanner_get_max_depth (self));
#line 31 "../src/baobab-scanner.vala"
		break;
#line 2385 "baobab-scanner.c"
		default:
#line 31 "../src/baobab-scanner.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 31 "../src/baobab-scanner.vala"
		break;
#line 2391 "baobab-scanner.c"
	}
}

static void
_vala_baobab_scanner_set_property (GObject * object,
                                   guint property_id,
                                   const GValue * value,
                                   GParamSpec * pspec)
{
	BaobabScanner * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, BAOBAB_TYPE_SCANNER, BaobabScanner);
#line 31 "../src/baobab-scanner.vala"
	switch (property_id) {
#line 31 "../src/baobab-scanner.vala"
		case BAOBAB_SCANNER_DIRECTORY_PROPERTY:
#line 31 "../src/baobab-scanner.vala"
		baobab_scanner_set_directory (self, g_value_get_object (value));
#line 31 "../src/baobab-scanner.vala"
		break;
#line 31 "../src/baobab-scanner.vala"
		case BAOBAB_SCANNER_SCAN_FLAGS_PROPERTY:
#line 31 "../src/baobab-scanner.vala"
		baobab_scanner_set_scan_flags (self, g_value_get_flags (value));
#line 31 "../src/baobab-scanner.vala"
		break;
#line 31 "../src/baobab-scanner.vala"
		case BAOBAB_SCANNER_SHOW_ALLOCATED_SIZE_PROPERTY:
#line 31 "../src/baobab-scanner.vala"
		baobab_scanner_set_show_allocated_size (self, g_value_get_boolean (value));
#line 31 "../src/baobab-scanner.vala"
		break;
#line 31 "../src/baobab-scanner.vala"
		case BAOBAB_SCANNER_TOTAL_SIZE_PROPERTY:
#line 31 "../src/baobab-scanner.vala"
		baobab_scanner_set_total_size (self, g_value_get_uint64 (value));
#line 31 "../src/baobab-scanner.vala"
		break;
#line 31 "../src/baobab-scanner.vala"
		case BAOBAB_SCANNER_TOTAL_ELEMENTS_PROPERTY:
#line 31 "../src/baobab-scanner.vala"
		baobab_scanner_set_total_elements (self, g_value_get_int (value));
#line 31 "../src/baobab-scanner.vala"
		break;
#line 31 "../src/baobab-scanner.vala"
		case BAOBAB_SCANNER_MAX_DEPTH_PROPERTY:
#line 31 "../src/baobab-scanner.vala"
		baobab_scanner_set_max_depth (self, g_value_get_int (value));
#line 31 "../src/baobab-scanner.vala"
		break;
#line 2441 "baobab-scanner.c"
		default:
#line 31 "../src/baobab-scanner.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 31 "../src/baobab-scanner.vala"
		break;
#line 2447 "baobab-scanner.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

